/*----------------------------------------------------------File: main.c------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

#include	<X11/Xlib.h> 
#include	<X11/Xutil.h>
#include	<xview/xview.h>
#include	<xview/frame.h>
#include	<xview/panel.h>
#include	<xview/openmenu.h>
#include	<xview/textsw.h>
#include	<xview/canvas.h>
#include	<xview/xv_xrect.h>
#include	<xview/scrollbar.h>
#include	<xview/cursor.h>

/*#include	"libaudio.h"	*//*From Sun multimedia*/
/*#include	"audio_device.h"		*//*From Sun multimedia*/
#include 	"vartalaap.h"
#include	"posdefs.h"
/*#include	"audio.h"*/
#include	"color.h"
#include	"bb.h"

#include 	"../common/talklib.h"
#include 	"../common/protodefs.h"


extern	void		quit_proc () ;
extern	void		make_menu_proc () ;
extern	void		join_menu_proc () ;
extern	Panel_setting	name_proc () ;
extern	Notify_value	receive_msg () ;
extern	Notify_value	ReadAudioData () ;

void	init () ;
void	prepare_base () ;


Panel		panel ;
extern	int	L_sock ;
extern	int	L_Ausock ;
extern	int	IN_ANNOTATE ;
/*extern	BUFFER_POOL	FreeQ ;*/

extern	short	logo_bits[] ;
short pen_curs_bits[] = {
        0x0000,0x0000, 0x0000,0x0000, 0x3000,0x0000, 0x3800,0x0000,
        0x1F80,0x0000, 0x0840,0x0000, 0x0860,0x0000, 0x0890,0x0000,
        0x0908,0x0000, 0x0604,0x0000, 0x0202,0x0000, 0x0103,0x0000,
        0x0087,0x8000, 0x004F,0xC000, 0x003F,0xE000, 0x001F,0xF000,
        0x000F,0xF800, 0x0007,0xFC00, 0x0003,0xFE00, 0x0001,0xFF00,
        0x0000,0xFF80, 0x0000,0x7FC0, 0x0000,0x3F20, 0x0000,0x1E10,
        0x0000,0x0C08, 0x0000,0x0410, 0x0000,0x0220, 0x0000,0x0140,
        0x0000,0x0080, 0x0000,0x0000, 0x0000,0x0000, 0x0000,0x0000
} ;

/* VT globals*/
/****
int VOX_Out_Sizes[8] = {
        VOX_SIZE, VOX_SIZE, VOX_SIZE, VOX_SIZE,
        VOX_SIZE, VOX_SIZE, VOX_SIZE, VOX_SIZE
        };

int VOX_In_Sizes[8] = {
        VOX_SIZE, VOX_SIZE, VOX_SIZE, VOX_SIZE,
        VOX_SIZE, VOX_SIZE, VOX_SIZE, VOX_SIZE
        };
***/

/*Audio stuff*/
/*char	*Audio_dev ="/dev/audio" ;*/
/*Audio_hdr	Dev_hdr ;*/


/*----------------------------------------------------------------main()------*/
int	main( argc, argv)
int	argc ;
char	*argv[] ;
{

	/* Init. the x arguments first */
	if(xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv, NULL) == NULL)
	{
			printf("[FATAL]: Cannot connect to the display server\n") ;
			exit(0);
	}

	/* Initialise the other variables */
	init ( argc, argv);

	/* Prepare and display the base frame and prompt */
	prepare_base() ;

	/* The infinite loop*/
	xv_main_loop(base_frame) ;

}


/*---------------------------------------------------------------init ()------*/
void	init (argc, argv)
int	argc ;
char	*argv[] ;
{

	int	grp_no ;
	int	i ;
	FILE	*fp ;
	
	char	*Info = NULL;
	int		Ilen = 0 ;
	char	*pptr ;
	char	c ;
	struct	stat	fbuf ;
	int		fsize ;

/*Setting the debug switch */
	debug_mode = 0;
#ifdef	DEBUG
	debug_mode = 1;
#endif

	getlogname(CurrUsername) ;
	
	BBoardMode = FALSE ;
	/*Scan the other command line args */
	ScanArgs( argc, argv) ;

	/*Initialise the vars */
	for( grp_no=0; grp_no<MAX_GRP_NO; grp_no++)
	{
		usr_grp_list[grp_no].group_id = -1 ;
		number_of_displayed_images[grp_no] = 0 ;
                prev_strlen[grp_no] = 0 ; /*Used to get send data */

		for(i=0; i<MAX_USERS; i++)
		{
			UserWin[grp_no][i].State = UNUSED ;
			StartTxtPos[grp_no][i] = 0 ;
		}
		StartImgIndx[grp_no]= 0 ;

		AudioStop[grp_no] = TRUE ;

		DrawingOn[grp_no] = FALSE ;
		CurrBBoardObj[grp_no] = NONE ;
		InTextMode[grp_no] = FALSE ;
		Line_Width[grp_no] = 1 ;
		Curr_Color[grp_no] = 0 ; /*BLACK*/
		Line_Style[grp_no] = LineSolid ;
		Fill_Style[grp_no] = NONE ;
		Font_Family[grp_no] = 0 ;
		Font_Style[grp_no] = 0 ;
		Font_Size[grp_no] = WIN_SCALE_MEDIUM ;
		ph_flag[grp_no] = 0 ;
		/* init the current font *//*WORKHERE*/ 

		/* Set the image flag to NOT_DISPLAYED */
        for( i=0; i<MAX_IMAGES; i++)
           Image[grp_no][i].flag = NOT_DISPLAYED ;

		/* Set the ulist_bases to  NULL */
		ulist_base[grp_no] = NULL ;
		ulist_displayed[grp_no] = FALSE ;

		/* Init. the locations of messages*/
        for ( i=0 ; i<MAX_MSG_NO; i++)
               location[grp_no][i].pos = -1 ; 

	}
/* The photo stuff */
	/* Participant's pic is expected in .photo file in PHOTOPATH.
		File could be xbm, gif , jpeg, or pbm format. */
	if ( getenv("PHOTOPATH") != NULL)
		strcpy(ppath, getenv ("PHOTOPATH") ) ;
	else
		ppath[0] = '\0' ;
	if ( (strlen(ppath )!= 0) && (ppath[strlen(ppath) -1] != '/'))
		strcat(ppath,"/") ;
	strcat(ppath,".photo") ;
	/* Read all the data into UserPhoto */
	if ( (fp = fopen(ppath,"r") )== NULL)
	{
		fprintf(stderr,"Cannot find your photo. \n") ;
		fprintf(stderr,"Set PHOTOPATH to the directory \n containing your .photo file\n") ;
		exit(1) ; 
	}
	else
	{
		fstat(fileno(fp), &fbuf) ;
		photosize = fbuf.st_size ;
		UserPhoto =(char *)Malloc((photosize +2)* sizeof(char)) ;
		pptr = UserPhoto ;
		i = 0 ;
		while ((i++) < photosize)
			*pptr++ = fgetc(fp) ;
		*pptr = '\0' ;
	}

/* For audio .. TEST */
	/*aufp = fopen("aufile1","w") ;*/

/**	
   if (!Make_Bfr_Pool(&FreeQ, INIT_BUF_COUNT, MAX_PKT_SIZE))
   {
      printf("Data buffers not allocated.\n");
      exit(1);
   }
**/
/***
   if (!Make_Bfr_Pool(&FreeQ, INIT_BUF_COUNT, VOX_SIZE))
   {
      printf("Data buffers not allocated.\n");
      exit(1);
   }
***/

	NO_OF_GRP = 0 ;
	DrawingFlag = OFF ;
	IN_ANNOTATE = FALSE ;

	/* the rgb */
	for (i=0; i<256;i++)
	{
		r[i]=random()&0xff;
		g[i]=random()&0xff;
		b[i]=random()&0xff;
	}

	/* Set the fsgamcr (from xv ) */
	GenerateFSGamma () ;

	/* Create a server image to use as cursor's image */
	pen_svr_image = (Server_image)xv_create( XV_NULL, SERVER_IMAGE,
						XV_WIDTH, 32,
						XV_HEIGHT, 32,
						SERVER_IMAGE_BITS,      pen_curs_bits,
						NULL ) ;
 
	/* Create cursor */
	pen_cursor = (Xv_Cursor) xv_create( XV_NULL, CURSOR,
				CURSOR_IMAGE, pen_svr_image,
				NULL) ;

	/*Set count to zero .. Number of characters typed and not yet send */
	count=0 ;

	/* Initialisations for Audio part */
/**
	NVP.DefaultVocoder = VOCODER_PCM ;
	NVP.VocoderType = VOCODER_PCM ;
	NVP.VOX_in_pkt_size = VOX_In_Sizes[NVP.DefaultVocoder] ;
	NVP.VOX_out_pkt_size = VOX_Out_Sizes[NVP.DefaultVocoder] ;
	NVP.Recondly = DEFAULT_RECONDLY ;
	NVP.Low_Queue = DEFAULT_LOW_QUEUE ;
	NVP.No_Late_Discard = FALSE ;
***/
/*
	NVP.SpeechTail = (SpeakerOn)?SPEECH_TAIL_LENGTH: 
								SPEECH_TAIL_LENGTH_CONF ;
	NVP.Mean_Q_Pos = DEFAULT_RECONDLY ;
*/
}


/*-------------------------------------------------------prepare_base ()------*/
void	prepare_base()
{
	Server_image	logo_image ;
	Panel_item		text_item ;
	char			logname[NAME_LENGTH] ;
	Icon			icon ;
	Frame			menu_frame ;
	Canvas			canvas ;
	Menu			grp_menu ;
	Notify_client	client = (Notify_client)ARBIT ; /*some arbit val.*/
	Window			xwin ;
	int				fd_flags  ;
	Notify_value	sigint_func () ;
	struct	stat	st ;
	int				err ;
	Panel			b_pnl1 ;
	Panel			b_pnl2 ;

	
	char	*Info = NULL ;
	int		Ilen = 0 ;

	XColor	rgb_col, hw_col ;
	int		status ;
	int		i ;

	/* Create the main base frame */
	base_frame = (Frame)xv_create(NULL, FRAME, 
		XV_HELP_DATA,	"VARTALAAP:base",
		XV_WIDTH,	BASE_WIDTH,
		XV_HEIGHT,	BASE_HEIGHT,	
		XV_X,		BASE_X,
		XV_Y,		BASE_Y,
		FRAME_LABEL,	"VARTALAAP",
		FRAME_SHOW_RESIZE_CORNER, FALSE,
		NULL ) ;

	logo_image = (Server_image)xv_create(NULL, SERVER_IMAGE,
		XV_HELP_DATA,	"VARTALAAP:base",
		XV_WIDTH,	LOGO_WIDTH,/*64,*/
		XV_HEIGHT,	LOGO_HEIGHT,/*64,*/
		SERVER_IMAGE_BITS,	logo_bits,
		NULL) ;

	icon = (Icon)xv_create(base_frame, ICON,
			XV_HELP_DATA,	"VARTALAAP:base",
			ICON_IMAGE,	logo_image,
			XV_X,	ICON_X,/*100,*/
			XV_Y,	ICON_Y,/*100,*/

			NULL ) ;
	xv_set( base_frame, FRAME_ICON, icon, NULL );

	/* Show logo */
	show_logo() ;

	server = (Xv_server) xv_get(xv_get(base_frame, XV_SCREEN), 
						SCREEN_SERVER) ;

	theDisplay = (Display *)xv_get( base_frame, XV_DISPLAY) ;
	theScreen = XDefaultScreenOfDisplay( theDisplay) ;
	theVisual = XDefaultVisual( theDisplay, XScreenNumberOfScreen(theScreen)) ;
	/* Set the black and white pixels */
	Black = XBlackPixel(theDisplay, 0) ;
	White = XWhitePixel(theDisplay, 0) ;

	theCmap = DefaultColormap(theDisplay, XScreenNumberOfScreen(theScreen)) ;
	ncells = DisplayCells(theDisplay, XScreenNumberOfScreen(theScreen)) ;
	disp_depth = XDefaultDepthOfScreen( theScreen) ;
	ncols = 1 << disp_depth ;
	if (ncols > 256) ncols = 256 ;
	if(disp_depth == 2) mono = 1; 
	else	mono = 0 ;

	/*Allocating the 6/6/6 RGB colors */
/****
	for ( i=0; i<256; i++)
	{
		def_xcol[i].flags = DoRed | DoGreen | DoBlue ;
		def_xcol[i].red =  (unsigned short)((i - ((int)(i/6))*6) * 51 );
		def_xcol[i].red =  (unsigned short)(256*def_xcol[i].red);
		def_xcol[i].green =(unsigned short)(((int)(i/6)*51) 
								- (int)(((int)((i-1)/6)*51)/256)*256)  ; 
		def_xcol[i].green =  (unsigned short)(256*def_xcol[i].green);
		def_xcol[i].blue =(unsigned short)((int)(i/36)*51) ; 
		def_xcol[i].blue =  (unsigned short)(256*def_xcol[i].blue);
		if(XAllocColor( theDisplay, theCmap, &def_xcol[i]) == 0)
				printf("FAILED\n")  ;
	}
****/
		

	/* Create the cursors */
	hand1 = XCreateFontCursor( theDisplay, XC_hand1) ;
	hand2 = XCreateFontCursor( theDisplay, XC_hand2) ;
	pencil = XCreateFontCursor( theDisplay, XC_pencil) ;
	watch = XCreateFontCursor( theDisplay, XC_watch) ;

	/* Initialise the clients var*/
	if ( T_init_talk_lib( CurrUsername, UserPhoto, photosize, 
					NULL, NULL,NULL) == -1)
	{
		/* Some error in init*/
		printf("\nCheck if the server is running\n") ;
		exit(1) ;
	};

	/* Open the audio device */
/****
	err = stat(Audio_dev, &st) ;
	if ( err<0 )
	{
		perror(Audio_dev) ;
		exit(1) ;
	}
	if (!S_ISCHR(st.st_mode))
	{
		exit(1) ;
	}
	Audio_fd = open(Audio_dev, O_RDWR | O_NDELAY) ;
	if ( Audio_fd < 0)
	{
		if (errno == EBUSY)
			fprintf(stderr,"%s:%s is busy\n", Audio_dev, Audio_dev) ;
		else
			fprintf(stderr,"%s: opening error \n", Audio_dev) ;
	}

	if (audio_get_record_config(Audio_fd, &Dev_hdr) != AUDIO_SUCCESS)
	{
		fprintf(stderr,"%s :%s is not a audio device \n", Audio_dev, Audio_dev);
		
	}
	fd_flags = fcntl(Audio_fd, F_GETFL, 0) ;
	(void) fcntl(Audio_fd, F_SETFL, fd_flags|FNDELAY) ;
***/
	/*AUDIO_INITINFO(&info) ;*/

/*TEST*/
/**
	if (audio_write_filehdr(fileno(aufp), &Dev_hdr, Info, Ilen) != AUDIO_SUCCESS)
	{
		printf("Error writing audio header \n") ;
		perror(aufp) ;
	}
***/

	/* Register the event to the notifier which looks 
			for input on the socket */
	notify_set_input_func( base_frame, receive_msg, L_sock ) ;
	/*notify_set_input_func( base_frame, ReadAudioData, Audio_fd ) ;*/
	notify_set_signal_func( base_frame, sigint_func, SIGINT, NOTIFY_ASYNC) ;

	canvas = (Canvas)xv_create(base_frame, CANVAS, NULL );
	xv_set( canvas, XV_SHOW, FALSE, NULL) ;

	panel = (Canvas)xv_create(base_frame, PANEL, 
			/*XV_HELP_DATA,	"VARTALAAP:base",*/
			XV_X,	xv_get(base_frame, XV_WIDTH)-140,
			XV_Y,	10,
			XV_WIDTH,	120 ,
			XV_HEIGHT,	100 ,
			NULL );

	b_pnl1 = xv_create(panel, PANEL_BUTTON,
			XV_HELP_DATA,	"VARTALAAP:quit",
			XV_X,	0,
			XV_Y,	0,
			PANEL_LABEL_STRING,	"QUIT",
			PANEL_NOTIFY_PROC,	quit_proc,
			NULL) ;

	grp_menu = (Menu)xv_create(NULL, MENU,
			MENU_NOTIFY_PROC, 	make_menu_proc,
			MENU_STRINGS,	"Make New Group", NULL, 
			MENU_ITEM,
				MENU_STRING,	"Join A Group",
				MENU_NOTIFY_PROC, 	join_menu_proc,
				MENU_PULLRIGHT,
					xv_create(canvas, MENU,
						MENU_TITLE_ITEM, " Group List:",
						MENU_NOTIFY_PROC,join_menu_proc,
							
						 MENU_STRINGS, "GRP#1","GRP#2","GRP#3", NULL,
						NULL) ,
				NULL,

			NULL ) ; 

	 (void) xv_create(panel, PANEL_BUTTON,
			XV_HELP_DATA,	"VARTALAAP:groupact",
			XV_X,	0,
			XV_Y,	40,
			PANEL_LABEL_STRING,	"Group-Action",
			PANEL_ITEM_MENU,	grp_menu,
			NULL );

	/*Defining cursor for button panel */
	basewin = xv_get(xv_get(panel, CANVAS_NTH_PAINT_WINDOW, 0),
			XV_XID) ;
	XSetWindowBackground(theDisplay, basewin, col_pixel[6] ) ;

	XDefineCursor( theDisplay, basewin, hand2 ) ;
	XFlush(theDisplay) ;

	window_fit(base_frame) ;
}

/*--------------------------------------------End of main.c ------------------*/
