/*------------------------------------------------------menu_rtn.c------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

#include	"vartalaap.h"
#include	"bb.h"
#include	"posdefs.h"
#include	"../common/talklib.h"
#include	"../common/protodefs.h"

extern	void	process_send() ;
extern	void	process_ulist() ;
extern	void	process_audiosend() ;
extern	void	process_audiostop() ;
extern	void	process_mark() ;
extern	void	process_image() ;
extern	void	draw_image() ;
extern	void	FloydDitherize1() ;
extern	int		find_group() ;

int		IN_ANNOTATE ;

Frame	make_grp_box () ;
void	snd_event_proc() ;
void	txt_event_proc() ;
void	rcv_event_proc() ;
void	print_info() ;

void	display_user_info() ;
void	display_user_photo() ;
void	info_repaint_proc() ;
void	print_info_repaint_proc() ;
void	h_display_user_info() ;
void	h_info_repaint_proc() ;
extern	void	quit_hist() ;

extern	unsigned long	col_pixel[] ;

/*----------------------------------------------------------errmsg ()---------*/
/*
*	This routine display the error message at linenumber of screen window.
*	The error message is in string.
*/
void	errmsg(string )
char	*string;
{

	Frame	error_frame ;
	Panel	error_panel ;
	int	response ;

	/* Create the error_frame */
	error_frame = xv_create( NULL, FRAME, NULL );

	/* Create the error_panel */
	error_panel = xv_create( error_frame, PANEL, NULL ) ;

	/* Notice */
	response = notice_prompt( error_panel, NULL,
		NOTICE_MESSAGE_STRINGS, string, NULL,
		NULL ) ;

	xv_destroy_safe ( error_frame) ;
}


/*---------------------------------------------------------joingrp ()---------*/
/*
*	This routine joins the user to a group.
*	Group option is taken in this routine itself.
*/

void	joingrp(grp_id)
int	grp_id;
{
	int		cols ;
	int		i ,j ;
	int		no_of_grp;
	int		user_id ;
	char	grp_no_str[50] ;
	FILE	*grp_filename ;
	FILE	*fp ;
	char	groupname[10 ] ;
	char	*pdata ;
	CL_PKT	*dptr[MAX_USERS];
	int		no_of_peers ;
	Window	win ;

	switch (T_join(grp_id, &user_id, &no_of_peers, dptr))
	{
		case _OtherFailure :
			sprintf(errstr,"Something wrong with the server. Cannot join Group#%d", grp_id+1);
			errmsg( errstr) ;
			break;

		case _NoError:
			/* Find the free entry in user group list */
			for(no_of_grp = 0; no_of_grp < MAX_GRP_NO ; no_of_grp ++)
			{
			if(usr_grp_list[no_of_grp].group_id == -1)
				break;
			}
					
			NO_OF_GRP ++;
			usr_grp_list[no_of_grp].group_id = grp_id;
			/* Other initialisations */
			number_of_displayed_images[grp_id] = 0 ;
			prev_strlen[grp_id] = 0 ;
			for( i=0; i<MAX_IMAGES; i++)
				Image[grp_id][i].flag = NOT_DISPLAYED ;
			/*Init. the locations of messages */
			for ( i=0 ; i<MAX_MSG_NO; i++)
				location[grp_id][i].pos = -1 ; 

			/* the group box*/
			grp_box_ptr [grp_id] = make_grp_box(grp_id, groupname) ;

			/* Added : For the blackboard */
			if ( BBoardMode)
				make_bboard( grp_id) ;

			/* You get a list of users who have already joined, assign a 
				canvas to each and maintain the UserWin table */
			/*First canvas always to the current user*/
			UserWin[grp_id][0].user_id = user_id ;/*userid returned by server */
			HistWin[grp_id][0].user_id = user_id ;/*userid returned by server */
			StartTxtPos[grp_id][0] = 0 ;
			StartImgIndx[grp_id] = dptr[0]->index ;/*WORKHERE*/ 
			UserWin[grp_id][0].State = USED ;
			strcpy(UserWin[grp_id][0].uname, CurrUsername) ;
			strcpy(UserWin[grp_id][0].pfname, ppath) ;
			display_user_info(0, grp_id) ;
			display_user_photo(0, grp_id) ;
			xv_set(UserWin[grp_id][0].info_canvas, XV_SHOW, TRUE, NULL);
			xv_set(UserWin[grp_id][0].txt_win, XV_SHOW, TRUE, NULL);
			for (i=1; i<= no_of_peers; i++)
			{
				UserWin[grp_id][i].user_id =dptr[i-1]-> userid;
				HistWin[grp_id][i].user_id =dptr[i-1]-> userid;
				UserWin[grp_id][i].State = USED ;
				StartTxtPos[grp_id][i] = dptr[i-1]->msgnum ;
				strcpy(UserWin[grp_id][i].uname, dptr[i-1]->username) ;
				strcpy(UserWin[dptr[i-1]->grp_id][i].pfname, ".photo") ;
				strcpy(UserWin[dptr[i-1]->grp_id][i].pfname, 
							tempnam(NULL, "VPHc")) ;
				if ( (fp = fopen(UserWin[dptr[i-1]->grp_id][i].pfname,"w") ) 
								== NULL)
				{
					/*Error processing here */
					fprintf(stderr,"Error opening temp photo file \n") ;
					exit(1) ;
				}
				pdata = dptr[i-1]->msg ;
				for (j=0; j < dptr[i-1]->nBytes; j++)
					fputc(*pdata++, fp) ;
				fclose(fp) ;
				/* Free the dptr->msg's memory : allocated in DoPackData*/
				Free(dptr[i-1]->msg) ;
				Free(dptr[i-1]->username) ;
				/* Free dptr.. allocated in join.c (lib) */
				Free(dptr[i-1]) ;

				display_user_info(i, grp_id) ;
				display_user_photo(i, grp_id) ;
				/* I think there is no need of the temporary photofiles now.
					Delete */
				unlink(UserWin[grp_id][i].pfname) ;
				xv_set(UserWin[grp_id][i].info_canvas, XV_SHOW, TRUE, NULL);
				xv_set(UserWin[grp_id][i].txt_win, XV_SHOW, TRUE, NULL);
			}

			xv_set(grp_box_ptr[grp_id], XV_HEIGHT, 
					(no_of_peers+1)*(UWC_HEIGHT+5)+BTN_PNL_HEIGHT+5, 
					XV_SHOW, TRUE, NULL) ;
			break;

		case _NoSuchGroup:
			sprintf( errstr,"Sorry, nobody has made Group#%d yet",
					grp_id+1) ;
			errmsg(errstr);
			break;

		case _GroupAlreadyJoined:
			sprintf( errstr,"Hey! You've already joined Group#%d",
					grp_id+1) ;
			errmsg(errstr);
			break;

		default :
			sprintf( errstr,"Acutally you should not be receiving this error");
			errmsg(errstr);
			break;
	}
}



/*------------------------------------------------------makenewgrp ()---------*/
/*
*	This routine makes a new group .
*/

void	makenewgrp(groupname)
char	*groupname ;
{
	int		grp_id;
	int		user_id;
	int		col ;
	int		i ;
	int		no_of_grp;
	char	grp_no_str[50] ;
	Window	win ;

	switch(T_make_new_group(&grp_id, &user_id))
	{
		case _OtherFailure :
			sprintf(errstr," Something wrong with the server. Says it cannot make a group") ;
			errmsg( errstr);
			break;

		case _NoSpaceLeft :
			sprintf( errstr, "ENOUGH.. i can't make any more groups") ;
			errmsg(errstr);
			break;

		case _NoError:
			/* Find the free entry in user group list */
			for(no_of_grp = 0; no_of_grp < MAX_GRP_NO ; no_of_grp++)
				if(usr_grp_list[no_of_grp].group_id == -1)
						break;
			NO_OF_GRP ++;	
			usr_grp_list[no_of_grp].group_id = grp_id;

			/* Other initialisations */
			number_of_displayed_images[grp_id] = 0 ;
			prev_strlen[grp_id] = 0 ;
			for( i=0; i<MAX_IMAGES; i++)
				Image[grp_id][i].flag = NOT_DISPLAYED ;
			/*Init. the locations of messages */
			for ( i=0 ; i<MAX_MSG_NO; i++)
				location[grp_id][i].pos = -1 ; 

			/* The group box*/
			grp_box_ptr [grp_id] = make_grp_box(grp_id, groupname) ;
			/* Added : For the blackboard */
			if (BBoardMode)
				make_bboard( grp_id) ;

			/*Assign the window to the user*/
			UserWin[grp_id][0].user_id = user_id ;/*userid returned by server */
			HistWin[grp_id][0].user_id = user_id ;/*userid returned by server */
			StartTxtPos[grp_id][0] = 0 ;
			UserWin[grp_id][0].State = USED ;
			strcpy(UserWin[grp_id][0].uname, CurrUsername) ;
			strcpy(UserWin[grp_id][0].pfname, ppath) ;
			display_user_info(0, grp_id) ;
			display_user_photo(0, grp_id) ;
			xv_set(UserWin[grp_id][0].info_canvas, XV_SHOW, TRUE, NULL) ;
			xv_set(UserWin[grp_id][0].txt_win, XV_SHOW, TRUE, NULL) ;
			xv_set(grp_box_ptr[grp_id], XV_HEIGHT, 
					(UWC_HEIGHT+5)+BTN_PNL_HEIGHT+5, 
				XV_SHOW, TRUE, NULL) ;
			
			break;


		default :
			sprintf(errstr, "Actually you should not be receiving this error. Something's wrong") ;
			errmsg( errstr );
			break;

		}
}


/*---------------------------------------------------------history ()---------*/
/*
*	This routine shows the history of the group talk.
*	Group id is taken from user in this routine.
*/
void	history( item, event)
Panel_item 	item ;
Event		*event ;
{
	int	grp_id = 0;

	/* Finding the group entry */
	grp_id = find_group( event) ;

	HistoryGroup = grp_id ;
				
	if(grp_id > NO_OF_GRP )	/* Group does not exist */
	{
		sprintf(errstr,"I think Group#%d does not exist. Just check",
		grp_id+1) ;
		errmsg(errstr);
	}
	else
	{
		switch	(T_HistoryReq(grp_id))
		{
				case _OtherFailure :
					sprintf(errstr,"Sorry, the history request for Group#%d failed", grp_id+1) ;
					errmsg( errstr) ;
					break;

				case _NoError :
					break ;
		}
	}
}


/*-------------------------------------------------------leave_grp ()---------*/
/*
*	This routine unables the user to leave a group.
*/

void	leave_grp( item, event)
Panel_item	item ;
Event		*event ;
{
	int 	i;
	int     response ;

	CurrGroupId = find_group( event) ;

	response = notice_prompt( btn_panel[CurrGroupId], NULL,
			NOTICE_FOCUS_XY,        event_x(event), event_y(event) ,
			NOTICE_MESSAGE_STRINGS, "Do you really want to leave?", NULL,
			NOTICE_BUTTON_YES,      "Yes",
			NOTICE_BUTTON_NO,       "Oops! No" ,
			NULL );

	if ( response == NOTICE_NO)
		return ; 


	switch(T_leave(CurrGroupId))
	{
		case	_NoError:
				/* Reset the contents of sub windows */
				for(i=0 ;i<MAX_USERS; i++)
					textsw_reset( UserWin[CurrGroupId][i].txt_win, 0,0) ;
				
				NO_OF_GRP --;

				/* Removing the entry of the group from user list */
				for( i = 0; i <= NO_OF_GRP; i ++)
				{
					if(usr_grp_list[i].group_id == CurrGroupId)
						break;
				}
				
				usr_grp_list[i].group_id = -1;
				ph_flag[CurrGroupId] = 0 ;
				/* Free the blackboard pixmaps *//*WORKHERE*/ 
				if (BBoardMode)
				{
					XFreePixmap(xv_get(canvas_paint_window(
							BBoard[CurrGroupId].bb_canvas), XV_DISPLAY),
						BBoard[CurrGroupId].bb_pixmap) ;
				}
				xv_destroy_safe ( grp_box_ptr [CurrGroupId]) ;
					
				break;

		case	_NoSuchGroup:
				errmsg("No such group ");
				break;

		case	_GroupNotJoined:
				errmsg("Group not joined");
				break;

		case	_OtherFailure:
				errmsg("General Failure");
				break;

		default:
				errmsg("invalid value passed by system call");
				break;
	}
}


/*----------------------------------------------------make_grp_box ()--------*/ 
Frame	make_grp_box(grp_id, groupname)
int		grp_id ;
char	*groupname ;
{

	Frame	group_frame ;
	Icon	icon ;
	Window	xwin ;
	Window	win ;
	int		i ;

	CurrGroupId = grp_id ;

	/* Currently, there is no use of groupname as user is not
	 allowed to refer by name,but only by numbers. Till such
	 facility is provided(ie groupname databases kept at servers;
	 we just display the grou number as group name */

	sprintf(groupname,"Group#%d", grp_id+1) ;
 
	/* the frame containing the group objects */
	group_frame = xv_create(NULL, FRAME,
		XV_HELP_DATA,	"VARTALAAP:grpframe",
		XV_WIDTH,       GBOX_WIDTH, 
		/*XV_HEIGHT,      GBOX_HEIGHT, */
		XV_X,		GB_OFFSET+(grp_id+1)*GB_X_MULT,
		XV_Y,		GB_OFFSET+(grp_id+1)*GB_Y_MULT ,
		FRAME_LABEL,    groupname,
		NULL) ;

 
	/* the panel to contain buttons */
	btn_panel[grp_id] = (Panel)xv_create( group_frame, PANEL,
					XV_HEIGHT,      BTN_PNL_HEIGHT,
					NULL) ;
	(void)xv_create( btn_panel[grp_id], PANEL_BUTTON,
		XV_HELP_DATA,	"VARTALAAP:list",
		PANEL_LABEL_STRING,     "Info",
		PANEL_NOTIFY_PROC,	print_info,
		NULL) ;

	(void)xv_create( btn_panel[grp_id], PANEL_BUTTON,
		XV_HELP_DATA,	"VARTALAAP:history",
		PANEL_LABEL_STRING,     "History",
		PANEL_NOTIFY_PROC,      history,
		NULL) ;

        
	(void)xv_create( btn_panel[grp_id], PANEL_BUTTON,
		XV_HELP_DATA,	"VARTALAAP:imagesend",
		PANEL_LABEL_STRING,     "ImageSend",
		PANEL_NOTIFY_PROC,      process_image,
 		NULL) ;

	(void)xv_create( btn_panel[grp_id], PANEL_BUTTON,
		XV_HELP_DATA,	"VARTALAAP:voice",
		PANEL_LABEL_STRING,     "Voice",
		PANEL_NOTIFY_PROC,      process_audiosend,
		NULL) ;

	(void)xv_create( btn_panel[grp_id], PANEL_BUTTON,
		XV_HELP_DATA,	"VARTALAAP:leave",
		PANEL_LABEL_STRING,     "Leave",
		PANEL_NOTIFY_PROC,      leave_grp,
		NULL) ;

	/* Defining cursor for button panel */
	xwin = (Window) xv_get(xv_get( btn_panel[grp_id], 
							CANVAS_NTH_PAINT_WINDOW, 0), XV_XID) ;

/*XSetWindowBackground( theDisplay, xwin, col_pixel[6]) ;*/
/*XSetWindowBorder( theDisplay, xwin, col_pixel[0]) ;*/
	XDefineCursor( theDisplay, xwin, hand1) ;
	XFlush(theDisplay) ;

	/*Create each users canvas*/
	for ( i=0; i< MAX_USERS; i++)
	{
		/* the info_canvas*/
		UserWin[grp_id][i].info_canvas = (Canvas) xv_create (group_frame, CANVAS,
						XV_HEIGHT,  INFO_HEIGHT,
						XV_WIDTH,   INFO_WIDTH ,
						XV_SHOW,	FALSE,
						XV_X,       0,
						XV_Y,      BTN_PNL_HEIGHT+i*(GBOX_HEIGHT/MAX_USERS+5),
						CANVAS_X_PAINT_WINDOW,	TRUE ,
						CANVAS_REPAINT_PROC,	info_repaint_proc ,
						/*CANVAS_AUTO_SHRINK, FALSE,*/
						/*CANVAS_AUTO_EXPAND, FALSE,*/
        				NULL ) ;
							
		UserWin[grp_id][i].txt_win = (Textsw)xv_create( group_frame, TEXTSW,
						/*CANVAS_REPAINT_PROC,    draw_bb,*/
						XV_HEIGHT,  UWC_HEIGHT,
						XV_WIDTH,   UWC_WIDTH ,
						XV_SHOW,	FALSE,
						XV_X,       INFO_WIDTH+5,
						XV_Y,      BTN_PNL_HEIGHT+i*(GBOX_HEIGHT/MAX_USERS+5),
        				NULL ) ;

		if ( i != 0 )
		{
			xv_set( UserWin[grp_id][i].txt_win, TEXTSW_BROWSING, TRUE, NULL) ;
			xv_set((Xv_window)xv_get(UserWin[grp_id][i].txt_win, 
											OPENWIN_NTH_VIEW,0),
				WIN_EVENT_PROC, rcv_event_proc,
				WIN_CONSUME_EVENTS,	MS_MIDDLE, NULL, 
				NULL) ;
		}

		win = xv_get( canvas_paint_window( UserWin[grp_id][i].info_canvas), 
					 XV_XID) ;
/*XSetWindowBackground( theDisplay, win, col_pixel[6]) ;*/
/*XSetWindowBorder( theDisplay, win, col_pixel[0]) ;*/
		UserWin[grp_id][i].info_gc = XCreateGC( theDisplay, win, 0, NULL); 
	}

	/* Defining cursor for the first window */
	xwin = (Window) xv_get(xv_get( UserWin[grp_id][0].txt_win, 
										OPENWIN_NTH_VIEW, 0), XV_XID) ;
/*XSetWindowBackground( theDisplay, xwin, col_pixel[6]) ;*/
/*XSetWindowBorder( theDisplay, xwin, col_pixel[0]) ;*/
	XDefineCursor( theDisplay, xwin, pencil) ;

	/* Only the first window is tobe taking input from kbd */
	xv_set((Xv_window)xv_get(UserWin[grp_id][0].txt_win, OPENWIN_NTH_VIEW, 0),
		WIN_EVENT_PROC,	snd_event_proc,
		WIN_CONSUME_EVENTS,		WIN_ASCII_EVENTS, NULL,
		NULL) ;

	xv_set(UserWin[grp_id][0].txt_win, TEXTSW_INSERTION_POINT, 1, NULL) ;

	/* Creating the History Window */
	hist_frame [grp_id] = xv_create(NULL, FRAME,
		XV_WIDTH, GBOX_WIDTH,
		XV_HEIGHT, UWC_HEIGHT,
		XV_X,	GB_OFFSET+(grp_id+1)*GB_X_MULT,
		XV_Y,	GB_OFFSET+(grp_id+1)*GB_Y_MULT,
		FRAME_LABEL, HIST_LABEL,
		FRAME_DONE_PROC, quit_hist,
		NULL ) ;

	/* Canvases for history win */
	for ( i=0 ; i<MAX_USERS; i++)
	{
		HistWin[grp_id][i].info_canvas = (Canvas) 
					xv_create(hist_frame[grp_id], CANVAS,
						XV_HEIGHT,	INFO_HEIGHT,
						XV_WIDTH,	INFO_WIDTH,
						XV_SHOW,	FALSE,
						XV_X,	0,
						XV_Y,	i*(GBOX_HEIGHT/MAX_USERS+5),
						CANVAS_REPAINT_PROC,	h_info_repaint_proc,
						NULL ) ;

		HistWin[grp_id][i].txt_win = (Textsw)
				xv_create( hist_frame[grp_id], TEXTSW,
						XV_HEIGHT,	UWC_HEIGHT,
						XV_WIDTH,	UWC_WIDTH,
						XV_SHOW,	FALSE,
						XV_X,		INFO_WIDTH+5,
						XV_Y,		i*(GBOX_HEIGHT/MAX_USERS+5),
						NULL) ;

		xv_set(HistWin[grp_id][i].txt_win, TEXTSW_BROWSING, TRUE, NULL) ;

		/*INFO_GC HERE*//*WORKHERE*/ 
		win = (Window) xv_get(xv_get(HistWin[grp_id][i].info_canvas, 
						CANVAS_NTH_PAINT_WINDOW, 0), XV_XID) ;
		HistWin[grp_id][i].info_gc = XCreateGC( theDisplay, win, 0, NULL); 

	} 

	/*the quit button */
	hist_panel[grp_id] = (Panel) xv_create(
				hist_frame[grp_id], PANEL,
				NULL) ;
	(void)xv_create(hist_panel[grp_id], PANEL_BUTTON, 
			PANEL_LABEL_STRING, "QUIT",
			PANEL_NOTIFY_PROC, 	quit_hist,
			NULL) ;

	return ( group_frame) ;

}

/*-----------------------------------------------------process_mark ()--------*/ 
void	process_mark( grp_id, userid)
int		grp_id ;
int		userid ;
{
	int     		msg_num, from, to ;
	char    		*select_str ;
	int				cursorpos ;
	int				orig_cursorpos ;
	int				start_mark, end_mark ;
	int				i ;
	Seln_holder		holder ;
	Seln_request	*response ;
	char			*ptr ;

	/* Get the selected strings from window */
	holder = selection_inquire( server, SELN_PRIMARY) ;

	response = selection_ask( server, &holder,
		SELN_REQ_FIRST,	NULL,
		SELN_REQ_LAST,	NULL,
		SELN_REQ_CONTENTS_ASCII,	NULL,
		NULL) ;

	/* set the ptr to beginning of data -- SELN_REQ_FIRST */
	ptr = response->data;
	/* "first" is data succeeding SELN_REQ_FIRST -- skip attr */
	start_mark = *(Textsw_index *)(ptr += sizeof(SELN_REQ_FIRST));
	ptr += sizeof(Textsw_index); /* skip over value of "first" */
	/* "last" is data succeeding SELN_REQ_LAST -- skip attr */
	end_mark  = *(Textsw_index *)(ptr += sizeof(SELN_REQ_LAST));
	ptr += sizeof(Textsw_index); /* skip over value of "last" */

	if ( userid < 0)
	{
		/* ERROR PROCESSING HERE*/
		errmsg("GOT -ve UID") ;
		return;
	}

	for (i=0 ;i<MAX_USERS;i++)
	{
		if( userid == UserWin[grp_id][i].user_id)
		{
			start_mark += StartTxtPos[grp_id][i] ;
			end_mark += StartTxtPos[grp_id][i] ;
			break ;
		}
	}

	switch( T_annotate( grp_id, userid, start_mark, end_mark))
	{
		case    _NoError:
				break;

		case    _GroupNotJoined:
				errmsg("Group not joined");
				break;

		case    _NoSuchGroup:
				errmsg("No such group ");
				break;

		case    _OtherFailure:
				errmsg("General Failure");
				 break;

		default:
				errmsg("invalid value passed by system call");
				break;
	}
}

/*----------------------------------------------------find_free_rec ()-------*/ 
int     find_free_rec(grp_id)
int     grp_id ;
{
	int		i ;

	for(i=0 ; i<MAX_IMAGES; i++ )
		if ( Image[grp_id][i].flag == NOT_DISPLAYED )
			return(i) ;
	return(-1) ;
}


/*----------------------------------------------------send_event_proc ()-----*/ 
void	snd_event_proc( window, event, arg)
Xv_window	window ;
Event		*event ;
Notify_arg	arg ;
{
	int		smark, emark ;

	if ( event_is_ascii(event))
	{
		/* If a key is pressed .. */
		if ( event_is_down(event) )
		{

			/* ... and if it is BACKSPACE then .. */
			/***
			if (event_action(event) == BACKSPACE_KEY)
			{
			
			**/	
			/* ... and if it is RETURN key then send */
			if ( event_action(event) == RETURN_KEY )
			{
				process_send( event)  ;
				count = 0 ;
			}
			else
			{
				/* Count the chars typed since last send.	
				   If count==MAX_CHARS then send */
				if (count++ >= MAX_CHARS)
				{
					process_send( event);
					count = 0 ;
				}
			} /*else*/
		
		}
	}
	else
		switch(event_action(event) ) {

			case LOC_MOVE:
			case LOC_DRAG:
				break ;
			case ACTION_SELECT:
			case MS_LEFT :
			case ACTION_ADJUST :
			case MS_MIDDLE :
				break ;
			case ACTION_MENU :
			case MS_RIGHT :
				break ;

			default :
				return ;
		}

}

/*----------------------------------------------------rcv_event_proc ()-----*/ 
void	rcv_event_proc( window, event, arg)
Xv_window	window ;
Event		*event ;
Notify_arg	arg ;
{
	int	smark, emark ;
	int	uid, gid ;

	/* TEST */
	xv_set( window, WIN_CURSOR, pen_cursor, NULL );

	/*Ignore all other events except the left button press
	  and release which indicate annotation */

	if (event_is_ascii(event))
		;
	else
		switch(event_action(event) ) {

			case LOC_MOVE:
				break ;
			case LOC_DRAG:
				break ;
			case ACTION_SELECT:
			case MS_LEFT :
				/* If annotate not started , start it */
				if ( IN_ANNOTATE == FALSE)
				{
					IN_ANNOTATE = TRUE ;
				}
				else
				{
					IN_ANNOTATE == FALSE ;

					find_uid_from_txtwin( event, &gid, &uid) ;
					process_mark( gid, uid) ;

				}
				
				break ;
			case ACTION_ADJUST :
			case MS_MIDDLE :
				break ;
			case ACTION_MENU :
			case MS_RIGHT :
				break ;

			default :
				return ;
		}
}


/*----------------------------------------------------process_ulist ()-----*/ 
/* Routine which starts the process fro displaying user list */

void	process_ulist( item, event)
Panel_item	item ;
Event	*event ;
{

	int grp_id = find_group( event) ;

	switch  (T_UserListReq(grp_id))
	{
		case _OtherFailure :
			errmsg("UserList: Other Failure") ;
			break;
		case _NoError :
			break ;
		default :
			errmsg("UserList: Unkonown error \n") ;
			break ;
	}
}

/*----------------------------------------------------quit_ulist ()-----*/ 
void    quit_ulist(item, event)
Panel_item      item;
Event           *event;
{
        int     grp_id ;

        /* Find group id from window id */
        grp_id = find_group_from_ulist_win( event) ;
		textsw_reset( ulist_textsw[grp_id], 0, 0) ;

        xv_destroy_safe( ulist_base[grp_id]) ;
		ulist_base[grp_id ] = NULL ;
		ulist_displayed[grp_id] = FALSE ;
}

/*---------------------------------------------------display_user_info() -----*/
void	display_user_info( indx, gid)
int		indx ;
int		gid ;
{
	Window	win ;	
	int		i ;

	win = (Window) xv_get(xv_get(UserWin[gid][indx].info_canvas, 
			CANVAS_NTH_PAINT_WINDOW, 0), XV_XID) ;

	/* Display the users info in the info box.
		Info might be... name and pix */

	/* currently just an indication */
	XSetForeground( theDisplay, UserWin[gid][indx].info_gc, Black) ;
	XSetBackground( theDisplay, UserWin[gid][indx].info_gc, White) ;
	XSetFunction( theDisplay, UserWin[gid][indx].info_gc, GXor) ;

/**
	for(i=0;i<strlen(UserWin[gid][indx].uname);i++)
		*(UserWin[gid][indx].uname+i)=	
				toupper(*(UserWin[gid][indx].uname+i)) ;
**/
	XSetLineAttributes(theDisplay, UserWin[gid][indx].info_gc, 3, LineSolid,
			CapProjecting, JoinMiter) ;
	XDrawRectangle(theDisplay, win, UserWin[gid][indx].info_gc, 0, 0,
					INFO_WIDTH-3, INFO_HEIGHT-50) ;
	
	XDrawRectangle(theDisplay, win, UserWin[gid][indx].info_gc, 5, INFO_HEIGHT-45,
					INFO_WIDTH-15, 35) ;
	XSetLineAttributes(theDisplay, UserWin[gid][indx].info_gc, 5, LineSolid,
			CapProjecting, JoinMiter) ;
	
	XDrawString( theDisplay, win, UserWin[gid][indx].info_gc, 10,INFO_HEIGHT-25, 
		UserWin[gid][indx].uname, strlen(UserWin[gid][indx].uname)) ;

}

void display_user_photo(indx, gid)
int	gid ;
int	indx ;
{
	int	DispDepth ;
	int		nullCount, imWIDE ;
	unsigned char	*idata, *ip, *pp, *lip ;
	int		half ;
	int		i, j;
	FILE	*fp ;	
	int		ftype ;
	Window	xwin ;

	/* Check if file exists for reading */
	if ( (fp = fopen(UserWin[gid][indx].pfname,"r") )== NULL)
	{
		sprintf(errstr,"Cannot find your photo, where is it?\n") ;
		errmsg(errstr) ;
		return ;/*WORKHERE*/ 
	}		
	/* check the format */
	get_image_format( UserWin[gid][indx].pfname, &ftype) ;
	if ( ftype == UNKNOWN)
	{
		sprintf(errstr,"Cannot understand the format of photo file \n") ;
		errmsg(errstr) ;
		return ;
	}
	CreateXImage ( UserWin[gid][indx].pfname, ftype) ;
	XFlush(theDisplay) ;

	xwin = (Window) xv_get(xv_get(UserWin[gid][indx].info_canvas, 
			CANVAS_NTH_PAINT_WINDOW, 0), XV_XID) ;

	DispDepth = XDefaultDepth( theDisplay, XScreenNumberOfScreen(theScreen)) ; 
	if ( DispDepth == 1)
	{
		theImage = XCreateImage( theDisplay,
			XDefaultVisualOfScreen(XDefaultScreenOfDisplay(theDisplay)), 
			DispDepth, XYPixmap, 0, NULL, pWIDE, pHIGH, 8, 0) ;

		if (!theImage) printf("Error CreateImage \n" ) ;

		theImage->data = (char *) malloc(pHIGH*pWIDE*sizeof(char)) ; 

		FloydDitherize1( theImage) ;
	}
	else
	if ( DispDepth == 8)
	{
		/* Sort the colormap and allocate colors reqd for the picture.
			These routines from XV */
		SortColormap() ;
		AllocColors() ;

		nullCount = ( 4 - (pWIDE % 4)) & 0x03 ;
		imWIDE = nullCount + pWIDE ;
		idata = (char *)Malloc(imWIDE*pHIGH*sizeof(char)) ;
		if (!idata) printf("Error .. memory allocation \n") ;

		for (i=0, pp=pic, lip=idata; i<pHIGH; i++ )
		{
			for (j=0 ; j<pWIDE; j++,pp++,lip++)
				*lip = (unsigned char ) col_pixel[*pp] ;
			for ( j=0; j<nullCount ; j++, lip++)
				*lip = 0 ;
		}

		theImage = XCreateImage( theDisplay,
			XDefaultVisualOfScreen(XDefaultScreenOfDisplay(theDisplay)), 
			DispDepth, ZPixmap, 0, (char *)idata, pWIDE, pHIGH, 32,imWIDE) ;

		if (!theImage) printf("Error CreateImage \n" ) ;
	}
	else
	if (DispDepth == 4)
	{
		SortColormap() ;
		AllocColors() ;
		 theImage = XCreateImage( theDisplay,
            XDefaultVisualOfScreen(XDefaultScreenOfDisplay(theDisplay)),
            DispDepth, ZPixmap, 0, NULL, pWIDE, pHIGH, 32, 0) ;
 
        if (!theImage) printf("Error CreateImage \n" ) ;
         
        idata= (char *) malloc(pHIGH*pWIDE*sizeof(char)) ; ;
        theImage->data = idata ;

		for (i=0, pp=pic, lip=idata; i<pHIGH; i++, lip+=4)
		{
			for (j=0, ip=lip , half=0; j<pWIDE; j++,pp++,half++)
			{
				if (ImageByteOrder(theDisplay) == LSBFirst)
				{
					if ( half&1) 
					{
						*ip = *ip + ((col_pixel[*pp]&0x0f)<<4); 
						ip++;
					}
					else
					{
						*ip = col_pixel[*pp]&0x0f ;
					}
				}
				else
				{
					if (half&1)
					{
						*ip = *ip + (col_pixel[*pp]&0x0f);
						ip++;
					}
					else
						*ip = (col_pixel[*pp]&0x0f) << 4 ;
				}
			}
		}
	
	}

	XPutImage(theDisplay, xwin, UserWin[gid][indx].info_gc, theImage,0,0,
	   0,0, pWIDE, pHIGH) ;		

	XSetLineAttributes(theDisplay, UserWin[gid][indx].info_gc, 3, LineSolid,
			CapProjecting, JoinMiter) ;
	XDrawRectangle(theDisplay, xwin, UserWin[gid][indx].info_gc, 0, 0,
					INFO_WIDTH-3, INFO_HEIGHT-50) ;

}

/*---------------------------------------------------h_display_userinfo() -----*/
void	h_display_user_info( indx, gid)
int		indx ;
int		gid ;
{
	Window	win ;	
	int		i ;

	win = (Window) xv_get(xv_get(HistWin[gid][indx].info_canvas, 
			CANVAS_NTH_PAINT_WINDOW, 0), XV_XID) ;

	/* Display the users info in the info box.
		Info might be... name and pix */

	/* currently just an indication */
	XSetForeground( theDisplay, HistWin[gid][indx].info_gc, Black) ;
	XSetBackground( theDisplay, HistWin[gid][indx].info_gc, White) ;
	XSetFunction( theDisplay, HistWin[gid][indx].info_gc, GXor) ;

	for(i=0;i<strlen(HistWin[gid][indx].uname);i++)
		*(HistWin[gid][indx].uname+i)=	
				toupper(*(HistWin[gid][indx].uname+i)) ;
	XSetLineAttributes(theDisplay, HistWin[gid][indx].info_gc, 3, LineSolid,
			CapProjecting, JoinMiter) ;
	XDrawRectangle(theDisplay, win, HistWin[gid][indx].info_gc, 5, 5,
					INFO_WIDTH-10, INFO_HEIGHT-40) ;
	
	XDrawRectangle(theDisplay, win, HistWin[gid][indx].info_gc, 5, INFO_HEIGHT-30,
					INFO_WIDTH-10, 25) ;
	XSetLineAttributes(theDisplay, HistWin[gid][indx].info_gc, 5, LineSolid,
			CapProjecting, JoinMiter) ;
	XDrawLine( theDisplay, win, HistWin[gid][indx].info_gc, 5, 5, INFO_WIDTH-10,
				INFO_HEIGHT-40) ;
	XDrawLine( theDisplay, win, HistWin[gid][indx].info_gc, 5, INFO_HEIGHT-40, 
				INFO_WIDTH-10, 5) ;
	
	XDrawString( theDisplay, win, HistWin[gid][indx].info_gc, 10,INFO_HEIGHT-15, 
		UserWin[gid][indx].uname, strlen(UserWin[gid][indx].uname)) ;
	XFlush(theDisplay) ;
}

/*---------------------------------------------------info_repaint_proc() -----*/
void	info_repaint_proc(canvas, pwin, dpy, xwin, area)
Canvas			canvas ;
Xv_Window		pwin ;
Display			*dpy;
Window			xwin ;
Xv_xrectlist	*area ;
{
	int indx,gid; 

	for (gid=0; gid<MAX_GRP_NO; gid++) 
		for(indx=0; indx<MAX_USERS; indx++)
		{
			if(( UserWin[gid][indx].info_canvas == canvas) && 
				( UserWin[gid][indx].State == USED) )
			{
				/*Avoid doing it multiple times */
				if (ph_flag[gid] == 1)
					return ;
				else
					ph_flag[gid] = 1;

				/*display_user_info(indx,gid) ;
				display_user_photo(indx, gid) ;*/
				return ;
			}
		}
}


/*--------------------------------------------------h_info_repaint_proc() -----*/
void	h_info_repaint_proc(canvas, pwin, dpy, xwin, area)
Canvas			canvas ;
Xv_Window		pwin ;
Display			*dpy;
Window			xwin ;
Xv_xrectlist	*area ;
{
	int i ;
	int j ;

	for(j=0; j<MAX_GRP_NO; j++)
	for(i=0; i<MAX_USERS; i++)
	{
		if( HistWin[j][i].info_canvas == canvas)
				h_display_user_info(i,j) ;
	}
}
	

/*--------------------------------------------------txt_event_proc() -----*/
void	txt_event_proc( window, event)
Xv_Window	window ;
Event		*event ;
{
	Window	win ;
	char	c ;
	
	win = xv_get(window, XV_XID) ;	

	if (!event_is_ascii(event))
		return ;

	if (event_is_up(event))
		return ;
	
	c = (char) event_action(event) ;

}	

/*-----------------------------------------------------hist_quit() ----------*/
void	hist_quit()
{
	int	i,j;

/******
	for (i=0; i<MAX_GRP_NO; i++)
	{
		if ( frame == hist_frame[i])
		{
			for(j=0; j<MAX_USERS; j++)
			{
				textsw_reset(HistWin[i][j].txt_win, 0, 0) ;
				printf("reset \n" );
			}
		}
	}
*****/
}

/*--------------------------------------------------print_info()-------------*/
void	print_info()
{
	Frame	info_frame ;
	Canvas	info_canvas ;
	Textsw	info_txt_win ;

	info_frame = xv_create( NULL, FRAME, NULL) ;
	
	info_canvas = (Canvas) xv_create (info_frame, CANVAS,
						XV_HEIGHT,  INFO_HEIGHT,
						XV_WIDTH,   INFO_WIDTH ,
						XV_SHOW,	FALSE,
						XV_X,       0,
						XV_Y,      BTN_PNL_HEIGHT*(GBOX_HEIGHT/MAX_USERS+5),
						CANVAS_X_PAINT_WINDOW,	TRUE ,
						CANVAS_REPAINT_PROC,	print_info_repaint_proc ,
        				NULL ) ;

		info_txt_win = (Textsw) xv_create( info_frame, TEXTSW,
						XV_HEIGHT,	UWC_HEIGHT,
						XV_WIDTH,	UWC_WIDTH,
						XV_SHOW,	FALSE,
						XV_X,		INFO_WIDTH+5,
						XV_Y,		(GBOX_HEIGHT/MAX_USERS+5),
						NULL) ;

		xv_set(info_txt_win, TEXTSW_BROWSING, TRUE, NULL) ;

}

/*---------------------------------------------print_info_repaint_proc() -----*/
void	print_info_repaint_proc(canvas, pwin, dpy, xwin, area)
Canvas			canvas ;
Xv_Window		pwin ;
Display			*dpy;
Window			xwin ;
Xv_xrectlist	*area ;
{
}
				

/*----------------------------------------------------End of file menu_rtn.c-*/ 

