/*---------------------------------------------------File:procs1.c------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

/****DELETE THIS
#include	<X11/Xlib.h> 
#include	<X11/Xutil.h>
#include	<xview/xview.h>
#include	<xview/frame.h>
#include	<xview/panel.h>
#include	<xview/openmenu.h>
#include	<xview/textsw.h>
#include	<xview/canvas.h>
#include	<xview/xv_xrect.h>
#include	<xview/scrollbar.h>
******/

#include	"vartalaap.h"

#include	"../common/talklib.h"
#include	"../common/protodefs.h"


Panel_setting	name_proc() ;
Panel_setting	make_new_group_proc() ;
void			quit_proc() ;
void			make_menu_proc() ;
void			join_menu_proc() ;
Frame			join_menu_frame ;

extern	int	L_sock ;
extern	int	L_Ausock ;
extern	Panel	panel ;
extern	Notify_value	receive_msg() ;

/*------------------------------------------------------------quit_proc ()----*/
void	quit_proc(item, event)
Panel_item	item;
Event		*event ;
{
	int     no_of_grp , i;
	int		response ;

	response = notice_prompt( panel, NULL,
		NOTICE_FOCUS_XY,	event_x(event), event_y(event) ,
		NOTICE_MESSAGE_STRINGS, "Do you really want to quit?", NULL,
		NOTICE_BUTTON_YES,	"Yes",
		NOTICE_BUTTON_NO,	"No" ,
		NULL );

	if ( response == NOTICE_YES)
	{

		/* Leave all the groups */
        for (no_of_grp = 0 ; no_of_grp < MAX_GRP_NO; no_of_grp++ )
			if ( usr_grp_list[no_of_grp].group_id != -1)
			{
				for (i=0; i<MAX_USERS; i++)
					textsw_reset( UserWin[no_of_grp][i].txt_win, 0,0) ;
				T_leave(usr_grp_list[no_of_grp].group_id) ;
			}
 
	
		xv_destroy_safe( base_frame) ;
		exit (0) ;
	}
	else
		return ;
}


/*------------------------------------------------------------name_proc ()----*/
Panel_setting	name_proc( item, event)
Panel_item	item;
Event		*event ;
{

	Frame	menu_frame ;
	Canvas	canvas ;
	Menu	grp_menu;
	char	*username ;
	Panel	panel ;

	switch(event_action(event)) 
	{

	case '\n':
	case '\r':
	case '\033':
		username = (char *)xv_get(item, PANEL_VALUE) ;
		strcpy(CurrUsername ,username );
		/* Initialise the clients var*/
		T_init_talk_lib( username, NULL, NULL,NULL) ;

		xv_destroy_safe( item) ;

		/* Register the event to the notifier which looks 
			for input on the socket */
		notify_set_input_func( base_frame, receive_msg, L_sock ) ;

		canvas = (Canvas)xv_create(base_frame, CANVAS, 
				NULL );

		panel = (Canvas)xv_create(base_frame, PANEL, 
				XV_HELP_DATA,	"VARTALAAP:base",
				XV_X,	xv_get(base_frame, XV_WIDTH)-140,
				XV_Y,	10,
				XV_WIDTH,	120 ,
				XV_HEIGHT,	100 ,
				NULL );

		(void)xv_create(panel, PANEL_BUTTON,
				XV_HELP_DATA,	"VARTALAAP:base",
			XV_X,	0,
			XV_Y,	0,
			PANEL_LABEL_STRING,	"QUIT",
			PANEL_NOTIFY_PROC,	quit_proc,
			NULL) ;

		grp_menu = (Menu)xv_create(NULL, MENU,
				XV_HELP_DATA,	"VARTALAAP:base",
			MENU_NOTIFY_PROC, 	make_menu_proc,
			MENU_STRINGS,	"Make New Group", NULL, 
			MENU_ITEM,
				MENU_STRING,	"Join A Group",
				MENU_NOTIFY_PROC, 	join_menu_proc,
				MENU_PULLRIGHT,
					xv_create(canvas, MENU,
						MENU_TITLE_ITEM, " Group List:",
						MENU_NOTIFY_PROC,	join_menu_proc,
							
						 MENU_STRINGS, "GRP#1","GRP#2","GRP#3", NULL,
						NULL) ,
				NULL,

			NULL ) ; 

		(void)xv_create(panel, PANEL_BUTTON,
				XV_HELP_DATA,	"VARTALAAP:base",
			XV_X,	0,
			XV_Y,	40,
			PANEL_LABEL_STRING,	"Group-Action",
			PANEL_ITEM_MENU,	grp_menu,
			NULL );
		
		break ;

	default :
		return(panel_text_notify(item,event)) ;
	}

}
	


/*-------------------------------------------------------make_menu_proc ()----*/
void	make_menu_proc(menu, menu_item)
Menu 		menu ;
Menu_item	menu_item ;
{
	char	groupname[20] ;
	makenewgrp (groupname) ;
}


/*--------------------------------------------------make_new_group_proc ()----*/
/* This function not used currently */

Panel_setting
make_new_group_proc( item, event)
Panel_item	item;
Event	*event ;
{
	char	*groupname ;

	switch(event_action(event)) 
	{

		case '\n':
		case '\r':
		case '\033':
			groupname = (char *) xv_get(item, PANEL_VALUE) ;
			xv_destroy_safe( cmd_frame) ;
			break ;
		default :
			break ;
	}

	/* process for making the group */
	makenewgrp (groupname) ;

	/* the frame containing the group objects */
	return(panel_text_notify(item,event)) ;
}

/*-------------------------------------------------------join_menu_proc ()----*/
void	join_menu_proc( menu, menu_item)
Menu		menu ;
Menu_item	menu_item ;
{
	int	grp_id ;

	/* This is real crude.. Needs to be reaplced 
	  when group name facility is incorportated .
	  Also there is some hard coding about no of groups 
          here, as well as in menu listing which has to change */

	if (!(strcmp((char *)xv_get(menu_item, MENU_STRING),"GRP#1")))
	{
		grp_id = 0 ;
	}
	else
		if (!(strcmp((char *)xv_get(menu_item, MENU_STRING),"GRP#2")))
			grp_id = 1 ;
		else
			if (!(strcmp((char *)xv_get(menu_item, MENU_STRING),
							"GRP#3")))
			grp_id = 2 ;
			else
				grp_id = 0 ;  /* ???? */

	/* Remove the menu from display */
	xv_destroy_safe( join_menu_frame) ;

	/* Call the real routine whihc joins */
	joingrp( grp_id) ;
}


/*--------------------------------------------------End of file:  procs1.c--*/
