/*--------------------------------------------------File:receive.c------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

#include "vartalaap.h"
#include "posdefs.h"
/*#include "audio.h"*/
#include "bb.h"
#include "../common/talklib.h"
#include "../common/protodefs.h"
/*#include	"libaudio.h"	*//*From Sun multimedia*/
/*#include	"audio_device.h"*/		/*From Sun multimedia*/

/*extern	Audio_hdr	Dev_hdr ;*/
extern	unsigned long col_pixel[];

 
static char rfill_images[21][8] = {
    {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00},
    {0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00},
    {0x00, 0x40, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00},
    {0x00, 0x40, 0x00, 0x10, 0x00, 0x04, 0x00, 0x00},
    {0x00, 0x44, 0x00, 0x00, 0x00, 0x44, 0x00, 0x00},
    {0x00, 0x44, 0x00, 0x10, 0x00, 0x44, 0x00, 0x00},
    {0x88, 0x00, 0x22, 0x00, 0x88, 0x00, 0x22, 0x00},
    {0x88, 0x00, 0x32, 0x00, 0x88, 0x00, 0x23, 0x00},
    {0xc4, 0x00, 0x31, 0x00, 0x8c, 0x00, 0x23, 0x00},
    {0x99, 0x00, 0xcc, 0x00, 0x66, 0x00, 0x33, 0x00},
    {0x55, 0x00, 0x55, 0x00, 0x55, 0x00, 0x55, 0x00},
    {0x55, 0x22, 0x55, 0x08, 0x55, 0x22, 0x55, 0x00},
    {0x55, 0xa2, 0x55, 0x88, 0x55, 0xa2, 0x55, 0x2a},
    {0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa, 0x55, 0xaa},
    {0x55, 0xaa, 0x77, 0xaa, 0x55, 0xaa, 0xdd, 0xaa},
    {0x55, 0xae, 0x5f, 0xae, 0x55, 0xea, 0xf5, 0xea},
    {0x5d, 0xb6, 0x7f, 0xd5, 0x7f, 0xb6, 0x5d, 0xaa},
    {0x77, 0xff, 0x77, 0xaa, 0x77, 0xff, 0x77, 0xaa},
    {0x77, 0xdd, 0x7f, 0xbe, 0x7f, 0xdd, 0x77, 0xaa},
    {0x77, 0xff, 0x7f, 0xbe, 0x7f, 0xff, 0x77, 0xaa},
    {0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff},
	} ;

extern	char	CurrUsername[] ;
extern	int	MessageNumber[] ;
extern	isock ;

FILE	*testfp ;

void    display_text() ;
void    display_bb_obj() ;
/*void    output_audio() ;*/
void    addnewlines() ;
extern	void    quit_ulist() ;
void    display_hist_text() ;
void    display_userlist() ;
void    display_image() ;
void    display_hist_image() ;
void    display_annotate() ;
void    display_imagemark() ;
void	show_list() ;
void	allocate_win() ;
void	deallocate_win() ;

extern	piv_x, piv_y ;

int	total_pkts, pkts_got ;
int	nxt_pkt = FIRST ;
char	*cfname ; /*compressed-file name *//*WORKHERE*/ 


/*----------------------------------------------------------------filt ()-----*/
void	filt()
{
}
	
/*---------------------------------------------------------receive_msg ()-----*/
/*
*	This program receives the messages for the user and displays it.
*/

Notify_value	receive_msg(client, fd)
Notify_client	client ;
int	fd ;
{
	int		grp_no,i;
	int		cursorpos ;
	int		response;
	int		grp_id ;
	CL_PKT	data_pkt ;


	/* Receiving messages for hte groups which has been joined by client */
	switch(T_receive(&data_pkt ))
	{
		case	_NoMessage:
			break;

		case 	_HistMessage :
			display_hist_text( &data_pkt) ;
			break; 
			
		case	_HistImageMessage :
			display_hist_image( &data_pkt) ;
			break; 

		case    _UserListMessage :
			display_userlist( &data_pkt) ;
			break ;

		case	_JoinGroupIndication :
			allocate_win(&data_pkt) ;
			break ;

		case	_LeaveGroupIndication :
			deallocate_win(&data_pkt) ;
			break ;


		case	_AnnotateMessage:
			display_annotate( &data_pkt) ;
			break ;

		case	_ImagemarkMessage:
			display_imagemark( &data_pkt) ;
			break ;
					
		case	_T_Data:
		case	_NoError:
			display_text( &data_pkt) ;
			break;

		case	_BB_Data:
			display_bb_obj( &data_pkt) ;
			break ;

		case	_BB_Char:
			display_bb_char(&data_pkt) ;
			break ;
		
		case 	_I_Data:
			display_image( &data_pkt) ;
			break ;

		case	_IS_Data:
			ReceiveImage() ; /*WORKHERE*/ 
			close(isock) ;/*WORKHERE*/ 
			break ;

/***
		case	_AS_Data:
			ReceiveAudio() ; 
			break ;
**/

/**
	
		case	_V_Data:
			output_audio( &data_pkt) ;
			break ;
**/

		case	_NoSuchGroup:
			errmsg("Receive : No such group");
			break;

		case	_GroupNotJoined:
			errmsg("Receive : Group not joined");
			break;

		case	_OtherFailure:
			/* Panic condition: server failed */
			grp_no = data_pkt.grp_id ;
			response = notice_prompt( 
				btn_panel[grp_no],  NULL,
				NOTICE_MESSAGE_STRINGS,
					"VARTALAAP","Looks like the server went down!!", "Should i Quit?", NULL,
				NOTICE_BUTTON_YES, "OfCourse",
				NOTICE_BUTTON_NO, "No",
				NULL) ;

			if ( response == NOTICE_YES)
			{
				/* Leave all the groups */
				for (grp_no = 0 ; grp_no < MAX_GRP_NO; grp_no++ )
					if ( usr_grp_list[grp_no].group_id != -1)
       				{ 		
						for(i=0 ; i<MAX_USERS; i++)
       						textsw_reset( UserWin[grp_no][i].txt_win, 0,0) ;
       					T_leave(usr_grp_list[grp_no].group_id) ;
       				}
                   
        
       				xv_destroy_safe( base_frame) ;
				exit(0) ;
       			}


			break;

		default:
			/*errmsg("receive:returns unknown value");*/
			printf("ERROR: receive:returns unknown value");
			break;

	}/*end of switch*/

}


/*-----------------------------------------------------display_text ()--------*/
/* Display the text data received */

void	display_text( dptr)
CL_PKT	*dptr ;
{
	int	i ;
	Window	win ;
	/*char 	messg[BUFLEN] ;*/

	
	/*find the canvas of the user */
	for (i=0; i<MAX_USERS; i++)
	{
		if (UserWin[dptr->grp_id][i].user_id == dptr->userid )
		{

			/* If BACKSPACE */
			/***
			if ( )
			{
				textsw_erase(UserWin[dptr->grp_id][i].txt_win,
						xv_get(UserWin[dptr->grp_id][i].txt_win, TEXTSW_CONTENTS,
							prev_strlen[CurrGroupId], messg, BUFLEN)-1 , ) ;
						xv_get(UserWin[dptr->grp_id][i].txt_win, TEXTSW_CONTENTS,
							prev_strlen[CurrGroupId], messg, BUFLEN) ) ;
				Free(dptr->username) ;
				return ; 
			}
			***/
			/*Add text to receive window */
			textsw_insert( UserWin[dptr->grp_id][i].txt_win, dptr->msg, 
				strlen(dptr->msg) ) ;
			Free(dptr->username) ;	
			Free(dptr->msg) ;
			return ;
		}
	}

	/* WORKHERE*//*ERROR*/

	Free(dptr->username) ;	
	Free(dptr->msg) ;
}

/*----------------------------------------------------output_audio ()--------*/
/* Output the audio data received */
/***
void	output_audio( dptr)
CL_PKT	*dptr ;
{

	BUFFER	*bufp ;
	FILE	*fp ;


	bufp = (BUFFER *)(dptr->msg) ;
	write(fileno(testfp), (char *)(((MSGPTR )bufp)->vox_data), VOX_SIZE) ;
	NVP_vox_out(bufp) ;
	Check_Vox_Out_Q_CONF( bufp) ;
}
****/
/*----------------------------------------------------display_image ()--------*/
/* Display the image data received */

void    display_image( dptr)
CL_PKT	*dptr ;
{
 
	int     i ;
	char	*filename;
	char	command[2*MAXPATHLEN+40] ;
	FILE    *img_fp ;
	int		iftype ;

	if ( nxt_pkt == FIRST ) 
	{
		
		cfname = tempnam(NULL,"VCI"); /* name for compressed imagefile*/
		/* Appending .Z : reqd by uncompress */
		sprintf(cfname,"%s.Z",cfname) ;
		/* Create the bitmap file */
		img_fp = fopen(cfname,"w") ;
		if (img_fp == NULL)
 		{
			fprintf(stderr, "Error creating intermediate file \n") ;
			return ;
		}

		total_pkts = dptr->pkts_left +1;
		pkts_got = 0 ;

		/* Set the grp box as BUSY */
		xv_set( grp_box_ptr[dptr->grp_id], FRAME_BUSY, TRUE, NULL) ;
	}
	else
	{
		/* Open the bitmap file*/
		img_fp = fopen(cfname,"a") ;
		if (img_fp == NULL)
		{
			fprintf(stderr," Error opening intermediate file \n") ;
			return ;
		}
	}

	pkts_got++ ;
 
	/* Write into the bm file */
	if(write(fileno(img_fp), dptr->msg, dptr->nBytes) == NULL)
	{
		errmsg("Error writing intermediate file\n") ;
		return ;
	}
	/* Free the memory of dptr->msg */
	Free( dptr->msg) ;

	fclose(img_fp) ;
	if ( pkts_got == total_pkts )	
	{
		filename = tempnam(NULL,"VI") ; /* Image file name */

		/* The file type has to be got as a header info. in the 
		 image pkt */
		switch (dptr->image_type)
		{
			case 0 :/*XBM*/
				/* USe uncompress to get XBM file */
				sprintf ( command, 
					"uncompress -c %s > %s", 
						cfname, filename) ;
				system ( command) ;
				break ;
			case 1 :/*JPEG */
				/* Use djpeg to uncompress */
				sprintf ( command, 
					"djpeg   %s > %s", 
						cfname, filename) ;
				system ( command) ;
				break ;
			default :
				break ;
		}
				
				
	/* Call the routine to creat the image */
	if (create_image( grp_box_ptr[dptr->grp_id], dptr->grp_id,
			dptr->username, filename, &iftype, FALSE) ==-1)
	{
		errmsg("Error creating image \n");
		return ;
	}
	xv_set( grp_box_ptr[dptr->grp_id], FRAME_BUSY, FALSE, NULL) ;

	/* Remove the temporary image files */
	unlink(filename) ;
	unlink(cfname) ;
	
	/* Free memory allocated by tempnam */
	free(filename) ;
	free(cfname) ;
	}/*end of if*/

	if ( dptr->pkts_left != 0 )
		nxt_pkt = NOT_FIRST ;
	else
		nxt_pkt = FIRST ;

	return ;
}



/*--------------------------------------------------display_hist_image ()----*/ 
void    display_hist_image( dptr) 
CL_PKT	*dptr ;
{

	FILE    *fp ;
	int     i ;
	char	command[50] ;
	char	*filename;
	char	hist_label[HIST_LABEL_LEN] ;
	int		iftype ;

	if ( nxt_pkt == FIRST)
	{
		/* Create the bitmap file */
		cfname = tempnam(NULL,"VCI") ; /* Compressed image filenmae */
		/* Appending .Z : reqd by uncompress */
		sprintf(cfname,"%s.Z",cfname) ;
		fp = fopen(cfname,"w") ;
		
		if (fp == NULL)
		{
			errmsg(stderr, "Error creating intermediate file \n") ;
			return ;
		}

		total_pkts = dptr->pkts_left +1 ;
		pkts_got = 0 ;
	}
	else
	{
		/*Open the bitmap file */
		fp = fopen(cfname,"a") ;
		if (fp == NULL)
		{
			errmsg(stderr, "Error opening intermediate file \n") ;
			return ;
		}
	}

	pkts_got++ ;
	
	/* Write the compressed-file */
	if(write(fileno(fp), dptr->msg, dptr->nBytes) == NULL)
	{
		errmsg(stderr,"Error writing intermediate file\n") ;
		return ;
	}

	fclose(fp) ;
	Free( dptr->msg) ;

    /* Call the routine to creat the image */
	if ( pkts_got == total_pkts)
	{
		filename=tempnam(NULL,"VI"); /* Image file name */

		/* The file type has to be got as a header info. in the
                 image pkt */
		switch (dptr->image_type)
		{
			case 0 :/*XBM*/
				/* USe uncompress to get XBM file */
				sprintf ( command, "uncompress -c %s > %s",
							cfname, filename) ;
				system ( command) ;
				break ;

			case 1 :/*JPEG */
				/* Use djpeg to uncompress */
				sprintf ( command, "djpeg  %s > %s", cfname, filename) ;
				system ( command) ;
				break ;
			default :
				break ;
		}
                        

		sprintf( hist_label,"%s%d", HIST_LABEL, dptr->grp_id+1) ;
		/* Create the base frame */
		/*Call the routine to create the image */
		if (create_image( hist_frame[dptr->grp_id], dptr->grp_id, 
			dptr->username, filename, &iftype, TRUE) ==-1)
		{
			errmsg("Error creating image \n");
			return ;
		}

		/* Remove the temporary files */
		unlink( filename);
		unlink( cfname) ;
		/* Free memory allocated by tempnam */
		free( filename);
		free( cfname);
	}

	if ( dptr->pkts_left != 0 )
		nxt_pkt = NOT_FIRST ;
	else
		nxt_pkt = FIRST ;
			
	return ;
}

/*----------------------------------------------------display_hist_text ()----*/

void    display_hist_text ( dptr)
CL_PKT	*dptr ;
{
	int     i ;
	char	hist_label[HIST_LABEL_LEN];

	for (i=0; i<MAX_USERS; i++)
	{
		if (HistWin[dptr->grp_id][i].user_id == dptr->userid)
		{

			sprintf(hist_label,"HISTORY [%s%d]", HIST_LABEL, dptr->grp_id+1) ;
			xv_set( hist_frame[dptr->grp_id], FRAME_LABEL, hist_label, NULL) ; 
			/* Add text*/
			textsw_insert( HistWin[dptr->grp_id][i].txt_win, dptr->msg,
										strlen(dptr->msg)) ;
			xv_set(HistWin[dptr->grp_id][i].txt_win, XV_SHOW, TRUE, NULL) ;
			xv_set(HistWin[dptr->grp_id][i].info_canvas, XV_SHOW, TRUE, NULL) ;

			/* Change the frame_size only if it is increasing*/
			if ( xv_get(hist_frame[dptr->grp_id], XV_HEIGHT) <
					( (i+1)*(UWC_HEIGHT+5)+BTN_PNL_HEIGHT+5) )	
				xv_set(hist_frame[dptr->grp_id], XV_HEIGHT, 
					(i+1)*(UWC_HEIGHT+5)+BTN_PNL_HEIGHT+5, 
					NULL) ;

			xv_set(hist_panel[dptr->grp_id], 
					XV_X,	10,
					XV_Y,	xv_get(hist_frame[dptr->grp_id], XV_HEIGHT)-25,
					NULL );

			xv_set(hist_frame[dptr->grp_id], XV_SHOW, TRUE, NULL) ;
			Free(dptr->msg) ;
			return ;
		}
	}

	Free( dptr->msg) ;

}



/*--------------------------------------------find_group_from_hist_win ()----*/ 
int	find_group_from_hist_win( event)
Event	*event ;
{
	int	i ;

	/* Match the hist win ptr and fidn the group */
	
	for(i=0; i< MAX_GRP_NO; i++)
	{
		if( event->ie_win == hist_panel[i] )	
			return(i) ;
	}
	return(-1) ;
}



/*--------------------------------------------find_group_from_ulist_win ()---*/ 
int	find_group_from_ulist_win( event)
Event	*event ;
{
	int	i ;
	/* Match the hist win ptr and fidn the group */
	
	for(i=0; i< MAX_GRP_NO; i++)
	{
		if( event->ie_win == ulist_panel[i] )	
			return(i) ;
	}
	return(-1) ;
}


/*--------------------------------------------display_annotate ()---*/ 
/* Show the mark as recieved */
void    display_annotate( dptr)
CL_PKT	*dptr ;
{
        int     i ;
		for (i=0 ; i<MAX_USERS; i++)
		{
			if ( UserWin[dptr->grp_id][i].user_id == dptr->userid)
			{

				if (dptr->from > StartTxtPos[dptr->grp_id][dptr->userid])
					textsw_set_selection( UserWin[dptr->grp_id][i].txt_win,
						dptr->from-StartTxtPos[dptr->grp_id][i], 
						dptr->to+1-StartTxtPos[dptr->grp_id][i], 1) ;
				return ;
			}
		}
}

/*--------------------------------------------display_imagemark ()---*/ 
void	display_imagemark( dptr)
CL_PKT	*dptr; 
{
	int	b, h;
	Display	*disp ;
	Window	win ;
	int	img_index ;

	img_index = dptr->index - StartImgIndx[dptr->grp_id] ; 
	if ( img_index < 0 ) 
		return ;

	/*Drawing the mark */

	Image[dptr->grp_id][img_index].lastX = dptr->startx ;
	Image[dptr->grp_id][img_index].lastY = dptr->starty ;
	Image[dptr->grp_id][img_index].currentX = dptr->endx ;
	Image[dptr->grp_id][img_index].currentY = dptr->endy ;

	/* Getting positive width and height */
	b = Image[dptr->grp_id][img_index].currentX
			- Image[dptr->grp_id][img_index].lastX ;
	if ( b < 0 )
	{
		b = b * (-1.0) ;
		piv_x = Image[dptr->grp_id][img_index].currentX ;
	}
	else
		piv_x = Image[dptr->grp_id][img_index].lastX ;

	h = Image[dptr->grp_id][img_index].currentY
			-Image[dptr->grp_id][img_index].lastY ;
	if ( h < 0 )
	{
		h = h * (-1.0) ;
		piv_y = Image[dptr->grp_id][img_index].currentY ;
	}
	else
		piv_y = Image[dptr->grp_id][img_index].lastY ;

	disp = (Display *) xv_get( Image[dptr->grp_id][img_index].image_frame, 
					XV_DISPLAY) ;
	win = xv_get( canvas_paint_window( Image[dptr->grp_id][img_index].
						image_canvas), XV_XID);

	if ( dptr->mtype == RECT)
        	XDrawRectangle( disp, win, Image[dptr->grp_id][img_index].markgc, 
				piv_x, piv_y, b, h) ;
	else
        	XDrawArc( disp, win, Image[dptr->grp_id][img_index].markgc, 
				piv_x, piv_y, b, h, 0, 360*64) ;
	XFlush(disp) ;
}


/*--------------------------------------------display_userlist ()-------------*/
void    display_userlist( dptr)
CL_PKT	*dptr ;
{
	int     i ;
	int     cursorpos ;
	Window	xwin ;
	

/*WORKHERE*//*TEMP */
ulist_displayed[dptr->grp_id] = FALSE ;
 
	/* Prepare the frame and sub frames to display userlist */
	if ( ulist_displayed[dptr->grp_id] == FALSE )
	{
        /* Create the base frame */
        ulist_base[dptr->grp_id] = (Frame) xv_create(base_frame, FRAME,
		XV_HELP_DATA,	"VARTALAAP:ulist",
                XV_WIDTH,       UL_BASE_WIDTH, 
                XV_HEIGHT,      UL_BASE_HEIGHT, 
                FRAME_LABEL,    UL_LABEL, /*"Participants",*/
                NULL ) ;
 
        /* Create the userlist text window */
        ulist_textsw[dptr->grp_id] = (Textsw) xv_create( 
				ulist_base[dptr->grp_id], TEXTSW,
                XV_HEIGHT,      UL_TEXT_HEIGHT,
                XV_WIDTH,       UL_TEXT_WIDTH,
                XV_X,           UL_TEXT_X, 
                XV_Y,           UL_TEXT_Y, 
                NULL );

		/* Create the QUIT button */
/*WORKHERE*/
/* TEMP
		ulist_panel[dptr->grp_id] = (Panel) xv_create( 
			ulist_base[dptr->grp_id], PANEL,
			XV_X,	U_PNL_X,
			XV_Y,	U_PNL_Y,
			NULL) ;

		(void) xv_create( ulist_panel[dptr->grp_id], PANEL_BUTTON,
			PANEL_LABEL_STRING,	"QUIT",
			PANEL_NOTIFY_PROC,	quit_ulist ,
			NULL) ;
*****/

	}

	/* Clear the list textsubwin */
	if ( ulist_displayed[dptr->grp_id] == TRUE)
	{
		textsw_erase( ulist_textsw[dptr->grp_id], 1, TEXTSW_INFINITY) ;
	}
		
	ulist_displayed[dptr->grp_id] = TRUE ;

	/* The user list */
	addnewlines(dptr->msg) ;
	textsw_insert( ulist_textsw[dptr->grp_id], dptr->msg,
				strlen(dptr->msg) ) ;

	xv_set( ulist_base[dptr->grp_id], XV_SHOW, TRUE, NULL );

	Free(dptr->msg) ;
}


/*-----------------------------------------------------------show_list ()---*/ 
void	show_list( canvas, paint_window, dpy, xwin, xrects)
Canvas	canvas ;
Xv_window	paint_window;
Display	*dpy ;
Window	xwin ;
Xv_xrectlist	*xrects ;
{
	GC	listgc ;

	listgc = XCreateGC ( theDisplay, xwin, 0, NULL) ;
	XSetForeground(theDisplay, listgc, Black) ;
	XSetBackground(theDisplay, listgc, White) ;

	XDrawString( theDisplay, xwin, listgc, 10,10, userlist,
			strlen(userlist) ) ;
	XFlush( theDisplay) ;
}

 
/*--------------------------------------------------------addnewlines ()---*/ 
void	addnewlines(str)
char *str ;
{
	int 	i,j ;
	char    *buffer ;
	int		user_number ;
	char	in_space ;

	user_number = 1;

	buffer = (char *)Malloc( strlen(str) * sizeof(char)+10) ;
	/*Replace all spaces by a newline char in str */

	/*the number for names */

	in_space =FALSE ; 
	for (i=0, j=0 ; i<strlen(str) ;i++ )
	{
		if ( (*(str+i) == ' ') || !isascii(*(str+i)) )
		{
			i++ ;
			in_space = TRUE ;
			while ( *(str+i) == ' ') /* Ignore the contiguous spaces */
				i++ ;
			/* Adjust to the last space */
			i-- ;
		}
		else
		{
			if(in_space)
			{
				*(buffer+j++) = '\n' ;
				*(buffer+j++) =  '0'+ user_number;
				user_number++ ;
				*(buffer+j++) = ')' ;
				*(buffer+j++) = ' ' ;
				in_space = FALSE ;
			}

			*(buffer +j++) = toupper(*(str+i)) ;
		}
	}
	*(buffer+j) = '\0' ;
	/* Copy back to orig. string */
	strcpy( str, buffer) ;
	Free(buffer) ;

}


/*****
ReceiveAudio()
{
CL_PKT	data_pkt ;
char	*Info = NULL ;
int		Ilen = 0 ;
	if (audio_write_filehdr(Audio_fd, &Dev_hdr, Info, Ilen) != AUDIO_SUCCESS)
	{
		printf("Error writing header \n") ;
	}
testfp = fopen("rcvau","w") ;
	if (audio_write_filehdr(fileno(testfp), &Dev_hdr, Info, Ilen) != AUDIO_SUCCESS)
	{
		printf("Error writing header \n") ;
	}
	while(1)
	{
		
			switch(T_aureceive(&data_pkt))
			{
				case _V_Data :
					output_audio(&data_pkt) ;
					break ;
				default :
					printf("ERRORR\n") ;
					return ;
					break ;
			}
	}
}
****/
ReceiveImage()
{
	CL_PKT	data_pkt ;

	while (TRUE)
	{
		switch( T_imgreceive( &data_pkt) )
		{
			case _I_Data:
				display_image(&data_pkt) ;
				if ( data_pkt.pkts_left == 0)
					return ;
				break ;
			default :
				errmsg("Unknown pkt on image channel") ;
				return ;
				break ;
		}
	}
	return ;
}


/*-----------------------------------------------display_bb_obj ()------------*/
void    display_bb_obj( dptr)
CL_PKT	*dptr ;
{
	short	points[MAX_PTS] ;
	int		npoints ;
	Window	win ;

	int		grp_id ;
	int		i ;
	short	b,h, px,py ;
	short	x, y ;
	XPoint	xpts[30] ;

	grp_id = dptr->grp_id ;

	bcopy((char *)dptr->msg, (char *)points, dptr->nBytes) ;

	npoints = ( dptr->nBytes / (sizeof(short)*2)) ;

	win = (Window) xv_get(xv_get(BBoard[grp_id].bb_canvas,
				CANVAS_NTH_PAINT_WINDOW, 0), XV_XID) ;

	/* Set the gc attribute */
	XSetFunction( theDisplay, BBoard[grp_id].bb_gc, GXor); /*OR*/
	XSetFunction( theDisplay, BBoard[grp_id].bb_bgc, GXor); /*OR*/
/*Hack for -1 gettitn converted to 255 (in unsigned char ) */
if ( dptr->fstyle == 255)
	dptr->fstyle = NONE ;
	/* Set the fill_style */
	if ( dptr->fstyle != NONE)
	{
		rfill_tile[grp_id] = XCreatePixmapFromBitmapData( theDisplay, win,
			rfill_images[dptr->fstyle], 8, 8, 1, 0, 1) ;
		XSetFillStyle( theDisplay, BBoard[grp_id].bb_gc, TILED) ;
		XSetFillStyle( theDisplay, BBoard[grp_id].bb_bgc, TILED) ;
		XSetTile(theDisplay, BBoard[grp_id].bb_gc, rfill_tile[grp_id]) ;
		XSetTile(theDisplay, BBoard[grp_id].bb_bgc, rfill_tile[grp_id]) ;
	}
	XSetLineAttributes(theDisplay, BBoard[grp_id].bb_gc, dptr->lwidth,
		dptr->lstyle, CapProjecting, JoinMiter) ;
	XSetLineAttributes(theDisplay, BBoard[grp_id].bb_bgc, dptr->lwidth,
		dptr->lstyle, CapProjecting, JoinMiter) ;
	/**
	XSetForeground( theDisplay, BBoard[grp_id].bb_gc, col_pixel[dptr->color]) ;
	XSetForeground( theDisplay, BBoard[grp_id].bb_bgc, col_pixel[dptr->color]) ;
	**/

	switch( dptr->obj_type)
	{
		case ERASE:
			calculate_obj_size(grp_id, points[0],
				points[1], points[2],	
				points[3], &px, &py, &b, &h) ;
			
			/*Set the erase fill style */
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_gc, TILED) ;
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_bgc, TILED) ;
			XSetTile(theDisplay, BBoard[grp_id].bb_gc, erasetile) ;
			XSetTile(theDisplay, BBoard[grp_id].bb_bgc, erasetile) ;

			XSetFunction( theDisplay, BBoard[grp_id].bb_bgc, GXcopy) ;
			XSetForeground( theDisplay, BBoard[grp_id].bb_bgc, White) ;
			XSetBackground( theDisplay, BBoard[grp_id].bb_bgc, Black) ;
			XSetFunction( theDisplay, BBoard[grp_id].bb_gc, GXcopy) ;
			XSetForeground( theDisplay, BBoard[grp_id].bb_gc, White) ;
			XSetBackground( theDisplay, BBoard[grp_id].bb_gc, Black) ;
			XFillRectangle(theDisplay, win, BBoard[grp_id].bb_bgc, 
					px, py, b+1, h+1) ;

			XFillRectangle(theDisplay, BBoard[grp_id].bb_pixmap, 
					BBoard[grp_id].bb_gc,
					px, py, b+1, h+1) ;

			/*Reset the fill style */
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_gc, TILED) ;
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_bgc, TILED) ;
			XSetTile(theDisplay, BBoard[grp_id].bb_gc, fill_tile[grp_id]) ;
			XSetTile(theDisplay, BBoard[grp_id].bb_bgc, fill_tile[grp_id]) ;

			XSetForeground( theDisplay, BBoard[grp_id].bb_gc, Black) ;
			XSetBackground( theDisplay, BBoard[grp_id].bb_gc, White) ;
			XSetForeground( theDisplay, BBoard[grp_id].bb_bgc, Black) ;
			XSetBackground( theDisplay, BBoard[grp_id].bb_bgc, White) ;

			/* Refresh the grid if on */
			if (GRID[grp_id] == ON)
			{
				XSetFunction(theDisplay, BBoard[grp_id].bb_bgc, GXor) ;/*OR*/
				draw_grid(grp_id) ;
				XSetFunction(theDisplay, BBoard[grp_id].bb_bgc, GXxor) ;/*XOR*/
			}
			break ;


		case ARC:
		case RECT:

			calculate_obj_size(grp_id, points[0], points[1], points[2],
				points[3], &px, &py, &b, &h) ;
			if ( dptr->fstyle != NONE)
			{
				XFillRectangle(theDisplay, BBoard[grp_id].bb_pixmap, 
						BBoard[grp_id].bb_gc, px, py, b, h) ;
				XFillRectangle(theDisplay, win, BBoard[grp_id].bb_bgc, px, py, b, h) ;
			}
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_gc, FillSolid) ;
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_bgc, FillSolid) ;
			XSetLineAttributes(theDisplay, BBoard[grp_id].bb_gc, dptr->lwidth,
				dptr->lstyle, CapProjecting, JoinMiter) ;
			XSetLineAttributes(theDisplay, BBoard[grp_id].bb_bgc, dptr->lwidth,
				dptr->lstyle, CapProjecting, JoinMiter) ;
			XDrawRectangle(theDisplay, BBoard[grp_id].bb_pixmap, BBoard[grp_id].bb_gc, 
						px, py, b, h) ;
			XDrawRectangle(theDisplay, win, BBoard[grp_id].bb_bgc, px, py, b, h) ;

			break;

		case CIRC:
			calculate_obj_size(grp_id, points[0], points[1], points[2],
				points[3], &px, &py, &b, &h) ;
			if ( dptr->fstyle != NONE)
			{
				XFillArc(theDisplay, BBoard[grp_id].bb_pixmap, BBoard[grp_id].bb_gc, 
					px, py, b, h, 0, 64*360) ;
				XFillArc(theDisplay, win, BBoard[grp_id].bb_bgc, px, py,
					b, h, 0, 64*360) ;
			}
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_gc, FillSolid) ;
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_bgc, FillSolid) ;
			XSetLineAttributes(theDisplay, BBoard[grp_id].bb_gc, dptr->lwidth,
				dptr->lstyle, CapProjecting, JoinMiter) ;
			XSetLineAttributes(theDisplay, BBoard[grp_id].bb_bgc, dptr->lwidth,
				dptr->lstyle, CapProjecting, JoinMiter) ;
			XDrawArc(theDisplay, BBoard[grp_id].bb_pixmap, BBoard[grp_id].bb_gc, px, py,
				b, h, 0, 64*360) ;
			XDrawArc(theDisplay, win, BBoard[grp_id].bb_bgc, px, py,
				b, h, 0, 64*360) ;
			break;

		case POLYLINE:
			printf("Received polyline \n" );
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_gc, FillSolid) ;
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_bgc, FillSolid) ;
			XSetLineAttributes(theDisplay, BBoard[grp_id].bb_gc, dptr->lwidth,
				dptr->lstyle, CapProjecting, JoinMiter) ;
			XSetLineAttributes(theDisplay, BBoard[grp_id].bb_bgc, dptr->lwidth,
				dptr->lstyle, CapProjecting, JoinMiter) ;

			for (i=0; i<npoints-1; i++)
			{
				XDrawLine( theDisplay, BBoard[grp_id].bb_pixmap, BBoard[grp_id].bb_gc, 
						points[2*i], points[2*i+1], 
						points[2*i+2], points[2*i+3]) ;
				XDrawLine( theDisplay, win, BBoard[grp_id].bb_bgc, points[2*i], 
						points[2*i+1], points[2*i+2], points[2*i+3]) ;
			}
			break ;

		case POLYGON:
			/* Fill the XPoint structure with points */
			fill_rpolypoints(xpts, points, npoints) ;

			/* Fill the polygon*/
			XSetFunction( theDisplay, BBoard[grp_id].bb_gc, GXor);/*OR*/ 
			XSetFunction( theDisplay, BBoard[grp_id].bb_bgc, GXor);/*OR*/ 
			if ( dptr->fstyle!= NONE)
			{
				XFillPolygon ( theDisplay, BBoard[grp_id].bb_pixmap, 
					BBoard[grp_id].bb_gc,
					(XPoint *)xpts, npoints,
					Complex, CoordModeOrigin) ;
				XFillPolygon ( theDisplay, win, BBoard[grp_id].bb_bgc,
					(XPoint *)xpts, npoints,
					Complex, CoordModeOrigin) ;
			}
			/*Free(xpts) ;*/

			XSetFillStyle( theDisplay, BBoard[grp_id].bb_gc, FillSolid) ;
			XSetFillStyle( theDisplay, BBoard[grp_id].bb_bgc, FillSolid) ;
			XSetLineAttributes(theDisplay, BBoard[grp_id].bb_gc, dptr->lwidth,
				dptr->lstyle, CapProjecting, JoinMiter) ;
			XSetLineAttributes(theDisplay, BBoard[grp_id].bb_bgc, dptr->lwidth,
				dptr->lstyle, CapProjecting, JoinMiter) ;

			for(i=0;i<npoints-1; i++)
			{
				XDrawLine(theDisplay, BBoard[grp_id].bb_pixmap, BBoard[grp_id].bb_gc, 
						points[2*i], 
						points[2*i+1], 
						points[2*i+2], 
						points[2*i+3]) ;
				XDrawLine(theDisplay, win, BBoard[grp_id].bb_bgc, 
						points[2*i], 
						points[2*i+1], 
						points[2*i+2], 
						points[2*i+3]) ;
			}

			XDrawLine(theDisplay, BBoard[grp_id].bb_pixmap, BBoard[grp_id].bb_gc,
						points[2*i], 
						points[2*i+1], 
						points[0], 
						points[1]) ;
			XDrawLine(theDisplay, win, BBoard[grp_id].bb_bgc,
						points[2*i], 
						points[2*i+1], 
						points[0], 
						points[1]) ;
			break ;

		case SPLINE:
		case TEXT:
		default :
			break ;
	}

	if ( Fill_Style[grp_id] != NONE)	
	{
		XSetTile(theDisplay, BBoard[grp_id].bb_gc, fill_tile[grp_id]) ;
		XSetTile(theDisplay, BBoard[grp_id].bb_bgc, fill_tile[grp_id]) ;
	}
	XSetLineAttributes(theDisplay, BBoard[grp_id].bb_gc, Line_Width[grp_id],
		Line_Style[grp_id], CapProjecting, JoinMiter) ;
	XSetLineAttributes(theDisplay, BBoard[grp_id].bb_bgc, Line_Width[grp_id],
		Line_Style[grp_id], CapProjecting, JoinMiter) ;
	XSetFunction( theDisplay, BBoard[grp_id].bb_gc, GXxor); /*XOR*/
	XSetFunction( theDisplay, BBoard[grp_id].bb_bgc, GXxor); /*XOR*/
	XSetForeground( theDisplay, BBoard[grp_id].bb_gc, col_pixel[Curr_Color[grp_id]]) ;
	XSetForeground( theDisplay, BBoard[grp_id].bb_bgc, col_pixel[Curr_Color[grp_id]]) ;

}

/*-----------------------------------------------allocate_win ()------------*/
void	allocate_win( dptr)
CL_PKT	*dptr ;
{
	int		i,j;
	char	*pdata ;
	FILE	*fp ;

	for ( i=0; i<MAX_USERS; i++)
	{
		if (UserWin[dptr->grp_id][i].State == UNUSED)
		{

			StartTxtPos[dptr->grp_id][i] = dptr->msgnum ;
			UserWin[dptr->grp_id][i].State = USED ;
			UserWin[dptr->grp_id][i].user_id = dptr->userid ;
			StartTxtPos[dptr->grp_id][dptr->userid] = dptr->msgnum ;
			strcpy(UserWin[dptr->grp_id][i].uname, dptr->username) ;
			/* Write the photodata recd. into a temp file and store the
				filename*/
			strcpy(UserWin[dptr->grp_id][i].pfname, tempnam(NULL, "VPHc")) ;
			if ( (fp = fopen(UserWin[dptr->grp_id][i].pfname,"w") ) == NULL)
			{
				/*Error processing here */
				fprintf(stderr,"Error opening temp photo file \n") ;
				exit(1) ;
			}
			pdata = dptr->msg ;
			for (j=0; j < dptr->nBytes; j++)
				fputc(*pdata++, fp) ;
			fclose(fp) ;
			/*the repaint proc.. need not pass any parmas */
/*WORKHERE for displaying recd photo*/
			display_user_info(i, dptr->grp_id) ;
			display_user_photo(i, dptr->grp_id) ;
			/*No need of temp photo file now */
			unlink(UserWin[dptr->grp_id][i].pfname) ;

			xv_set(UserWin[dptr->grp_id][i].info_canvas, XV_SHOW, TRUE,NULL) ;
			xv_set(UserWin[dptr->grp_id][i].txt_win, XV_SHOW, TRUE,NULL) ;
			xv_set(grp_box_ptr[dptr->grp_id], XV_HEIGHT, 
					(i+1)*(UWC_HEIGHT+5)+BTN_PNL_HEIGHT+5,
					XV_SHOW, TRUE,NULL) ;
			return ;
		}
	}
}

/*-----------------------------------------------deallocate_win ()------------*/
void	deallocate_win( dptr)
CL_PKT	*dptr ;
{
	int	i;
	Window		win ;

	for(i=0 ; i< MAX_USERS; i++)
	{
		if ((UserWin[dptr->grp_id][i].State==USED) 
					&& (UserWin[dptr->grp_id][i].user_id == dptr->userid))
		{
			UserWin[dptr->grp_id][i].State = UNUSED ;
			/* Clear the info_canvas for window i*/
			win = (Window) xv_get( xv_get(UserWin[dptr->grp_id][i].info_canvas,
						CANVAS_NTH_PAINT_WINDOW, 0), XV_XID) ;
			XClearWindow(theDisplay, win) ;
		
			return ;
		}
	}
}
/*---------------------------------------------End of file: receive.c -----*/

