/*----------------------------------------------------File :send.c------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

#include        <sys/stat.h>
#include        <math.h>
#include     	"vartalaap.h" 
#include     	"bb.h" 
#include 	"../common/talklib.h"
#include 	"../common/protodefs.h"

#define	BUFLEN	500

extern	int MessageNumber[] ;

char	*getfiledata() ;

/*---------------------------------------------------------process_send ()-----*/

void	process_send ( event)
Event	*event ;
{
	char	messg[BUFLEN] ;
	int		next_pos ;
	int		nbytes ;
	CurrGroupId = find_group_from_sndwin( event) ;
	/* Read the new contents of send window */
	next_pos = (Textsw_index) xv_get (UserWin[CurrGroupId][0].txt_win, 
			TEXTSW_CONTENTS, prev_strlen[CurrGroupId],
			messg, BUFLEN) ;

	prev_strlen[CurrGroupId] = next_pos ;

	/* Send the data */
	nbytes = strlen(messg) ;

	switch(T_send(CurrGroupId,messg,nbytes))
	{
		case    _NoError:
			break;
 
		case    _GroupNotJoined:
			errmsg("Group not joined");
			break;
 
		case    _NoSuchGroup:
			errmsg("No such group ");
			break;

		case    _OtherFailure:
			break;

		default:
			errmsg("invalid value passed by system call");
			break;

	}
        
}


/*--------------------------------------------------------find_group ()--------*/
int	find_group( event)
Event	*event ;
{
	int	i; 
	
	/* Match the window ptr with that of the button panels
	 and from that find the group id */

	for (i=0; i< MAX_GRP_NO; i++)
	{
		if ( event->ie_win == btn_panel[i] )	
			return(i) ;
	}
	return(-1); 
}

/*-------------------------------------------------find_uid_from_txtwin ()-----*/
int	find_uid_from_txtwin( event, gid, uid)
Event	*event ;
int		*gid ;
int		*uid ;
{
	int	i;
	int	j;
	
	for(j=0;j<MAX_GRP_NO;j++)
	{
		for (i=0; i< MAX_USERS; i++)
		{
			if ( event->ie_win == (Xv_window) xv_get( UserWin[j][i].txt_win,
							OPENWIN_NTH_VIEW,0) )
			{
				(*gid) = j ;
				(*uid) = UserWin[j][i].user_id ;
				return ;
			}
		}
	}
	return ;
}

/*-----------------------------------------------find_group_from_sndwin ()-----*/
int	find_group_from_sndwin( event)
Event	*event ;
{
	int	i; 
	
	/* Match the window ptr with that of the sndwins 
	 and from that find the group id */

	for (i=0; i< MAX_GRP_NO; i++)
	{
		if ( usr_grp_list[i].group_id != -1)
		{
			if ( event->ie_win == (Xv_window) xv_get( UserWin[usr_grp_list[i].group_id][0].txt_win, 
							OPENWIN_NTH_VIEW,0) )	
			return(usr_grp_list[i].group_id) ;
		}
	}
	return(-1) ;
}

/*--------------------------------------------find_group_from_bbcanvas ()------*/
int	find_group_from_bbcanvas( event)
Event	*event ;
{
	int	i; 
	
	/* Match the window ptr with that of the bbcanvases 
	 and from that find the group id */

	for (i=0; i< MAX_GRP_NO; i++)
	{
		if ( usr_grp_list[i].group_id != -1)
		{
			if ( event->ie_win == (Xv_window) xv_get( 
							canvas_paint_window(BBoard[i].bb_canvas), XV_XID));
			return(i) ;
		}
	}
	return(-1) ;
}

/*----------------------------------------------find_group_from_bbmenu ()-----*/
int	find_group_from_bbmenu( menu)
Menu	menu;
{
	int	i; 
	Panel	panel ;
	
	panel = (Panel)xv_get(menu, MENU_CLIENT_DATA) ;

	/* Match the window ptr with that of the bb_panels 
	 and from that find the group id */
	for (i=0; i< MAX_GRP_NO; i++)
	{
		if( BBoard[i].bb_panel == panel)
			return(i) ;
	}
	return(-1) ;
}


/*----------------------------------------------find_group_from_bbpanel ()-----*/
int	find_group_from_bbpanel( event)
Event	*event ;
{
	int	i; 
	
	/* Match the window ptr with that of the bbcanvases 
	 and from that find the group id */

	for (i=0; i< MAX_GRP_NO; i++)
	{
		if ( usr_grp_list[i].group_id != -1)
		{
			if ( event->ie_win == BBoard[i].bb_panel);
			return(i) ;
		}
	}
	return(-1) ;
}


/*-----------------------------------------------transfer_image ()-------------*/
transfer_image(  event, grp_id, ftype)
Event	*event ;
int	grp_id ;
int	ftype ;
{
	int     nbytes;
	int     flag_EOF;
	char    *messg  ;
	char    *sendtext  ;
	int      messgnum ;
	char	*img_data ;
	int		no_of_pkts ;
	int		pkts_left ;
	int		total_bytes ;
	int		i ;
	unsigned	short	image_type ;


	switch( ftype)
	{
		case XBM :
			/* Compress the file by std. compression */
        	img_data = getfiledata((char *)img_fname, 
					&total_bytes, 0) ;
			/* Set the ftype var to XBM */
			image_type = (unsigned short)0 ; /* XBM*/
			/* Send the data */
			break ;
		
		case GIF :	
		case PBM :
			/* Compress the file using JPEG compression */
        	img_data = getfiledata((char *)img_fname, 
					&total_bytes, 1) ;
			/* Set the ftype to JPEG */
			image_type = (unsigned short)1 ;/* JPEG */
			/* Send the data */
			break ;
		case JFIF :/*WORKHERE*/ 
			/* Get the file data. Its already jpegged */
        	img_data = getfiledata((char *)img_fname, 
					&total_bytes, 2) ;
			/* Set the ftype to JPEG */
			image_type = (unsigned short)1 ;/* JPEG */
			break ;

		default :
			break ;
	}
			

	if (total_bytes == 0 )
		return ;

	no_of_pkts = (int) ceil( (double)total_bytes/(double)MAX_PKT_SIZE) ;

	pkts_left = no_of_pkts ;
	for ( i=0 ; i<no_of_pkts; i++)
	{	
		pkts_left -- ;
		messg = img_data + (MAX_PKT_SIZE)*i ;

		if (i == no_of_pkts-1)
			nbytes = total_bytes 
				- ((int) floor((double)total_bytes/
					(double) MAX_PKT_SIZE) * MAX_PKT_SIZE) ;
		else
			nbytes = MAX_PKT_SIZE ;
        	switch(T_sendimage(grp_id,messg,nbytes,pkts_left,&messgnum, 
						image_type))
		{
			case    _NoError:
                                break;
 
                	case    _GroupNotJoined:
                                flag_EOF = 1;
                                /*errmsg("Group not joined");*/
                                break;
 
                	case    _NoSuchGroup:

                                flag_EOF = 1;
                                /*errmsg("No such group ");*/
                                break;

                	case    _OtherFailure:
                                flag_EOF = 1;
                                /*errmsg("General Failure");*/
                                break;

                	default:
                                flag_EOF = 1;
                                /*errmsg("invalid value passed by system call");*/
                                break;

        	}
	} /*end of for */

}

/*-------------------------------------------------getfiledata ()--------------*/
char    *getfiledata(filename, bytes, type)
char    *filename  ;
int	*bytes ;
int	type ;
{

	FILE    *fp ;
	char    c;
	int    *data ;
	int    *tmp_ptr ;
	struct  stat    buf ;
	int		fsize ;
	char	command[2*MAXPATHLEN+40] ;
	char	*newfilename;
	int		i = 0 ;

	/* First Compress the bitmap file */

	newfilename = tempnam(NULL,"VCI") ;/*File name for compressed image */
	if (type == 0 )
		sprintf(command, "compress -c %s > %s", filename, newfilename) ;
	else
	if (type == 1)
/* This has to change. Using system call to compress by jpeg. Using
default values *//*WORKHERE*/ 
		sprintf( command,"cjpeg %s > %s", filename, newfilename) ;
	else
	if (type == 2)
		sprintf(command, "cp %s %s ", filename, newfilename) ;

	system ( command) ;

	if ((fp = fopen(newfilename,"r")) == NULL )
	{
		sprintf(errstr, "##Cannot open %s to read", filename ) ;
		errmsg(errstr) ;
		return(NULL) ;
 	}
	else
	{
		fstat(fileno(fp), &buf) ;
		fsize = buf.st_size ;

		(*bytes) = fsize ;
		data = (int *)Malloc ( fsize*sizeof(char)) ;
		tmp_ptr = data ;

		read ( fileno(fp), data, fsize) ;	
		fclose (fp) ;
		/* CHECK :*/
		/***
		fp = fopen("testbm","w") ;
		fsize = (*bytes) ;
		write( fileno(fp), data, fsize) ;
		fclose(fp) ;
		****/

		/* Remove temporary files*/
		unlink( newfilename) ;

		/* Free memory allocated by tempnam */
		free( newfilename) ;

		return((char *)data) ;
	}
}


/*-----------------------------------------------process_audiosend ()----------*/
void	process_audiosend ( item, event)
Panel_item	item ;
Event	*event ;
{

	int     CurrGroupId ;
	char	data[ MAX_AUDIO_LEN] ;
	int		bytes; 

/*** REMOVE THE FOLL IN LATER VERSION ***/
	sprintf(errstr,"No audio support in this version") ;
	errmsg(errstr) ;
	return ;
/*********/

	CurrGroupId = find_group(event) ;
printf("STARTING AU FOR GRP %d \n", CurrGroupId) ;

	/* First send the audio send request*/
	switch(T_startaudiochannel(CurrGroupId))
	{
		case _OtherFailure :
			sprintf(errstr," Something wrong with the server.") ; 
			errmsg( errstr);
			break;

		case _AudioReqRejected :
			sprintf( errstr, "Sorry, the audio channel is busy. Try later.") ;
			errmsg(errstr);
			break;

		case _NoError:
			/* Audio Request granted, get data from mike and send*/
			AudioStop[CurrGroupId] = FALSE ;
	
			break ;		
			

		case _GroupNotJoined:
		default :
			sprintf(errstr,"I dont know what happened" ); 
			errmsg(errstr) ;
			break ;
	}
}

/*------------------------------------------------------ReadAudioData ()-------*/
/**************

Notify_value ReadAudioData( client, fd)
Notify_client	client ;
int				fd ;
{
	int		cnt ;
	char	buf[AUDIO_BUF_SZ+2] ;

	if ( AudioStop[CurrGroupId] == FALSE)
	{
		sleep(1) ;
		cnt = read( Audio_fd, buf, AUDIO_BUF_SZ) ;

printf("Sending %d bytes to %d grp as audio \n", cnt, CurrGroupId) ;
		T_sendaudiodata(CurrGroupId, buf, cnt) ;
	
	}

}
****************************/
/*----------------------------------------------------process_audiostop ()-----*/

void	process_audiostop ( item, event)
Panel_item	item ;
Event	*event ;
{

	int     CurrGroupId ;

	CurrGroupId = find_group(event) ;

	AudioStop[CurrGroupId] = TRUE ;
	
	/* Send the signal to the server to terminate audio connection*/
	T_stopaudiochannel( CurrGroupId) ;

}
/*-------------------------------------------------End of File: send.c --------*/
