/*------------------------------------------------------receive.c-------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                              Vartalaap                                     */
/*----------------------------------------------------------------------------*/
/*                  Multimedia Multiparty  Conferencing System                */
/*                                                                            */
/*                                                                            */
/*                  Written by:VIJAY TALATI                                   */
/*                             ERNet Lab,                                     */
/*                             Department of Computer Science,                */
/*                             Indian Institute of Technology, Bombay 400076. */
/*                             E-mail : vijay@gateway.iitb.ernet.in           */
/*                                                                            */
/******************************************************************************/

/* to receive messages from a talk group */

#include	"../common/inc.h"
#include	"../common/protodefs.h"

#define		EXTERN	extern

#include	"clientlib.h"

/*------------------------------------------------------T_aureceive()----------*/
Status	T_aureceive( data_pkt)
register	CL_PKT	*data_pkt ;
{

	T_GenericReply	genrep ;
	int		nfds =0;
	FD		fd = asock ;


	ENTER_PROC ("Au Receive") ;

        /*      First check for dirty business by the client */
        if(INIT_LIB_FLAG == FALSE)
                FATAL("Library structures NOT initialised");


		
	if (!ReadBuffer(fd, (char *)&genrep, sizeof(T_GenericReply)) )
			return(_OtherFailure) ;
/*printf("Got reptype = %d \n", genrep.type ) ;*/

		switch(genrep.type )
		{

			case _T_Error:
				{
				T_Error	terr ;
				bcopy((char *)&genrep, (char *)&terr,
						sizeof(T_GenericReply)) ;
				ProcessError(&terr) ;
				break ;
				}

			case _V_Data:
				{
				T_Data	tdata ;

				DEBUG_LEVEL2((stderr,"In T_Data \n") );
		
				bcopy((char *)&genrep, (char *)&tdata,
						sizeof(T_GenericReply) ) ;

				/* Set the MessageNumber ??? */
				/*WORKHERE*/	

				if (DoPackData(&tdata, fd, data_pkt) != SUCCESS)
					return(_OtherFailure) ;

				return(genrep.type) ;
				break ;
				}

			default :
				ERROR("Unknown type of reply packet") ;
				DEBUG_LEVEL1((stderr,"opcode retd:%d\n", genrep.type)) ;
			
				return(_OtherFailure) ;
				break ;
		}/* end of switch */
}

/*------------------------------------------------------T_imgreceive()---------*/
Status	T_imgreceive( data_pkt)
register	CL_PKT	*data_pkt ;
{

	T_GenericReply	genrep ;
	int				nfds =0;
	FD				fd = isock ;


	ENTER_PROC ("Img Receive") ;

	/*      First check for dirty business by the client */
	if(INIT_LIB_FLAG == FALSE)
		FATAL("Library structures NOT initialised");

	if (!ReadBuffer(fd, (char *)&genrep, sizeof(T_GenericReply)) )
			return(_OtherFailure) ;

	switch(genrep.type )
	{

		case _T_Error:
		{
			T_Error	terr ;
			bcopy((char *)&genrep, (char *)&terr, sizeof(T_GenericReply)) ;
			ProcessError(&terr) ;
			break ;
			}

		case _I_Data:
			{
			T_Data	tdata ;

			DEBUG_LEVEL1((stderr,"In T_Data \n") );
		
			bcopy((char *)&genrep, (char *)&tdata, sizeof(T_GenericReply) ) ;

			ImageIndex[tdata.gid] = tdata.ImgIndx ;

			if (DoPackData(&tdata, fd, data_pkt) != SUCCESS)
				return(_OtherFailure) ;

			return(genrep.type) ;
			break ;
			}

		default :
			ERROR("Unknown type of reply packet") ;
			DEBUG_LEVEL1((stderr,"opcode retd:%d\n", genrep.type)) ;
			
			return(_OtherFailure) ;
			break ;
	}/* end of switch */
}
	
/*---------------------------------------------------DoPackData()--------------*/
/* The routine get the data received into the CL_PKT struct */
Status DoPackData( td, sock, dptr)
T_Data	*td ;
FD		sock ;
CL_PKT	*dptr ;
{

	ENTER_PROC ("DoPackData") ;

	/* Set the fields of CL_PKT struct from grep */

	dptr->grp_id = (unsigned short)td->gid ;
	dptr->pkt_type = td->type ;
	dptr->msgnum = ntohs(td->MsgNum );
	dptr->userid = (unsigned short)td->userid ;
	dptr->image_type = (unsigned short)td->image_type ;
	dptr->pkts_left = ntohs(td->pkts_left );

	dptr->nBytes = ntohl(td->nBytesData );
	
	/* Read in the data */
	if (ntohl(td->nBytesData )!= 0 )
	{
	int	len = (ntohl(td->nBytesData) + 3) & ~3;
	dptr->msg = (char *)Malloc(len + 1) ;
	ReadBuffer(sock, (char *)(dptr->msg), len) ;
	dptr->msg[ntohl(td->nBytesData)] = '\0' ;

	}
	
	/* Read in the username */
	{
	int	len = (ntohs(td->nBytesUser) + 3) & ~ 3; 
	dptr->username = (char *)Malloc(len+1) ;
	ReadBuffer(sock, (char *)(dptr->username) , len) ;
	dptr->username[ntohs(td->nBytesUser)] = '\0' ;
	}

	return(SUCCESS) ;
}

/*---------------------------------------------------DoPackBBObj()-------------*/
DoPackBBObj( bd, sock, dptr)
BB_Data	*bd ;
FD		sock ;
CL_PKT	*dptr; 
{
	ENTER_PROC ("DoPackBBObj") ;

	/* Set the fields of CL_PKT struct from grep */
	dptr->grp_id = bd->gid ;
	dptr->lstyle = bd->lstyle ;
	dptr->fstyle = bd->fstyle ;
	dptr->lwidth = ntohs(bd->lwidth );
	dptr->color = bd->color ;
	dptr->obj_type = bd->obj_type ;
	dptr->nBytes = htons(bd->nBytesData );
	
	/* Read in the data */
	{
	int	len = (htons(bd->nBytesData) + 3) & ~3;
	dptr->msg = (char *)Malloc(len + 1) ;
	ReadBuffer(sock, (char *)(dptr->msg), len) ;
	dptr->msg[ntohs(bd->nBytesData)] = '\0' ;

	}
	
	/* Read in the username */
	{
	int	len = (ntohs(bd->nBytesUser) + 3) & ~ 3; 
	dptr->username = (char *)Malloc(len+1) ;
	ReadBuffer(sock, (char *)(dptr->username) , len) ;
	dptr->username[ntohs(bd->nBytesUser)] = '\0' ;
	}

	return(SUCCESS) ;
}

/*---------------------------------------------------DoPackBBChar()------------*/
DoPackBBChar( bd, sock, dptr)
BB_Char	*bd ;
FD		sock ;
CL_PKT	*dptr; 
{

	/* Set the fields of CL_PKT struct from grep */

	dptr->grp_id = bd->gid ;
	dptr->font_size = bd->font_size ;
	dptr->font_style = bd->font_style ;
	dptr->font_family = bd->font_family ;
	dptr->letter = bd->letter ;
	dptr->pos_x = ntohs(bd->pos_x );
	dptr->pos_y = ntohs(bd->pos_y );

	return(SUCCESS) ;	
}

/*------------------------------------------------------T_receive()------------*/
Status	T_receive( data_pkt)
register	CL_PKT	*data_pkt ;
{

	T_GenericReply	genrep ;
	int				nfds =0;
	FD				fd = L_sock ;

	ENTER_PROC (" Receive") ;

	/*      First check for dirty business by the client */
	if(INIT_LIB_FLAG == FALSE)
		FATAL("Library structures NOT initialised");
		
	if (!ReadBuffer(fd, (char *)&genrep, sizeof(T_GenericReply)) )
			return(_OtherFailure) ;

	switch(genrep.type )
	{
		case _T_Reply:
			ERROR("Read reply while in receive") ;
			return(_OtherFailure) ;
			break ;

		case _T_Error:
			{
			T_Error	terr ;
			bcopy((char *)&genrep, (char *)&terr, sizeof(T_GenericReply)) ;
			ProcessError(&terr) ;
			break ;
			}

		case _H_Data:
		case _HI_Data:
			{
			T_Data	tdata ;
			DEBUG("In _H_DATA \n" ) ;

			bcopy((char *)&genrep, (char *)&tdata, sizeof(T_GenericReply)) ;

			if ( DoPackData(&tdata, fd, data_pkt) != SUCCESS)
					return(_OtherFailure) ;
				
			/* Return appropriate code */
			if ( genrep.type == _H_Data )
				return(_HistMessage) ;
			else
				return(_HistImageMessage) ;
			break ;
			}

		case _UL_Data:
			{
			T_Data	tdata ;
		
			DEBUG("In UL_Data \n") ;

			bcopy((char *)&genrep, (char *)&tdata, sizeof(T_GenericReply)) ;

			if (DoPackData(&tdata, fd, data_pkt) != SUCCESS)
				return (_OtherFailure) ;

			/* Return the code */
			return( _UserListMessage) ;
			break ;
			}

		case	_NU_Data: /*New user data */
			{
			/*WORKHERE*/
			T_Data	tdata ;
			
			DEBUG("In NU_Data \n") ;

			bcopy((char *)&genrep, (char *)&tdata, sizeof(T_GenericReply)) ;

			if (DoPackData(&tdata, fd, data_pkt) != SUCCESS)
				return (_OtherFailure) ;

			data_pkt->msgnum = tdata.MsgNum ;
			data_pkt->pkt_type = _NU_Data ;
			data_pkt->grp_id = (unsigned short)tdata.gid ;
			data_pkt->userid = (unsigned short)tdata.userid ;
			return(_JoinGroupIndication) ;
			break ;
			}

		case	_LU_Data: 
			{
			/*WORKHERE*/
			T_Data	tdata ;
			
			DEBUG("In LU_Data \n") ;

			bcopy((char *)&genrep, (char *)&tdata, sizeof(T_GenericReply)) ;

			data_pkt->pkt_type = _LU_Data ;
			data_pkt->grp_id = (unsigned short)tdata.gid ;
			data_pkt->userid = (unsigned short)tdata.userid ;
			return(_LeaveGroupIndication) ;
			break ;
			}
		case _A_Data :
			{
			A_Data	adata ;
				
			DEBUG("In _A_Data \n") ;
			
			bcopy((char *)&genrep, (char *)&adata, sizeof(T_GenericReply) ) ;

			/* Store adata into data_pkt */

			data_pkt->grp_id = (unsigned short)adata.gid ;
			data_pkt->userid = (unsigned short)adata.userid ;
			data_pkt->from = adata.From ;
			data_pkt->to = adata.To ;
			data_pkt->pkt_type = _A_Data ;

			/* Return the app. code */
			return(_AnnotateMessage) ;
			break ;
			}

		case _IM_Data :
			{
			IM_Data	idata ;
				
			bcopy((char *)&genrep, (char *)&idata, sizeof(T_GenericReply) ) ;
				
			/* Set the data_pkt */
			data_pkt->grp_id = idata.gid ;
			data_pkt->index = ntohs(idata.ImgIndx );
			data_pkt->startx = ntohs(idata.startx );
			data_pkt->starty = ntohs(idata.starty );
			data_pkt->endx = ntohs(idata.endx );
			data_pkt->endy = ntohs(idata.endy) ;
			data_pkt->mtype = idata.mark_type ;
			data_pkt->pkt_type = _IM_Data ;

			if (idata.ImgIndx < StartImageIndex[idata.gid])
			{
				DEBUG_LEVEL1((stderr,"Got mark for nonreceived image\n")) ;
				return(_NoMessage) ;
			}

			return(_ImagemarkMessage) ;
			break ;
			}

		case _T_Data:
		case _I_Data:
		case _V_Data:
			{
			T_Data	tdata ;

			DEBUG("In T_Data \n") ;
		
			bcopy((char *)&genrep, (char *)&tdata, sizeof(T_GenericReply) ) ;

			/* Set the MessageNumber */
			MessageNumber[tdata.gid] = tdata.MsgNum ;
			ImageIndex[tdata.gid] = tdata.ImgIndx ;

			if (DoPackData(&tdata, fd, data_pkt) != SUCCESS)
				return(_OtherFailure) ;

			return(genrep.type) ;
			break ;
			}

		case _BB_Data:
			{
			BB_Data	bdata ;

			bcopy((char *)&genrep, (char *)&bdata, sizeof(T_GenericReply) ) ;

			if (DoPackBBObj(&bdata, fd, data_pkt) != SUCCESS)
				return(_OtherFailure) ;

			return(genrep.type) ;
			break ;
			}

		case _BB_Char:
			{
			BB_Char	bdata ;
			
			bcopy((char *)&genrep, (char *)&bdata, sizeof(T_GenericReply)) ;

			if (DoPackBBChar(&bdata, fd, data_pkt) != SUCCESS)
				return(_OtherFailure) ;

			return(genrep.type) ;
			break ;
			}


		case	_AS_Data: /* Start listening for audio*/
			{
			AS_Data	asdata ;
			T_Data	tdata ;
			T_GenericReply	grep ;

			bcopy((char *)&genrep, (char *)&asdata, sizeof(T_GenericReply));

			asock = ConnectToServAudio( asdata.port) ;
			return(genrep.type) ;

			break ;
			}

		case	_IS_Data:
			{
			IS_Data	isdata ;
			T_GenericReply	grep ;

			bcopy((char *)&genrep, (char *)&isdata, sizeof(T_GenericReply)) ;
			isock = ConnectToServImage( isdata.port) ;
			return(genrep.type) ;
			break ;
			}
			
		default :
			ERROR("Unknown type of reply packet") ;
			DEBUG_VAL((stderr,"opcode retd:%d\n", genrep.type)) ;
			
			return(_OtherFailure) ;
			break ;
		}/* end of switch */
}
					

/*------------------------------------------------End of receive.c-------------*/
