

/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                Vartalaap                                   */
/*----------------------------------------------------------------------------*/
/*                     Multimedia Conferencing Software                       */
/*                                                                            */
/*                                Version 1.0                                 */
/*                                                                            */
/*        Written by:                                                         */
/*                        Yezdezard Lashkari                                  */
/*                        Viswanath Ramachandran                              */
/*                        Sanjay Malpani                                      */
/*        Modified by :                                                       */
/*                        Vijay Talati                                        */
/*                                                                            */
/*                                                                            */
/*                Department of Computer Science and Engineering              */
/*                Indian Institute of Technology, Bombay 400076.              */
/*                                                                            */
/******************************************************************************/


/*
 *	Local Server Data Structures Typedef 
 */

#include	"../common/inc.h"

#define MAXPROC  15 	/* how many processes can use 1 local server for
			   multi talk */

#define	MAX_FILE_SZ		8000

#define	ImageFileFlag	128

#define	MAXPARTICIPANTS		10
#define	MAX_PARTICIPANTS_PER_SESSION		25

#define	EMPTY	-1	

#define		BUSY	1
#define		FREE	0

#define	AUDIO_PORT			5500

#define	BACKLOG		5

typedef struct proc {
	long pid;	
	long aupid;
	FD sock;
	FD ausock ;
	char user[MAXNAMESZ];	
	int lreqno;   
} PROC_TAB[MAXPROC];

typedef struct {
	int procs[MAXPROC];		
	int nprocs;	
}LOCAL_TAB[VNGROUPS];	


PROC_TAB proc_tab;
LOCAL_TAB local_tab;

/* The structure containing the information regarding the participants */
typedef	struct	participant {
	FD	fd ;	/* the socket of the participant */
	char	*Name ;			/* Name of the participant */
	char	*Description ;	/* Additional description, if provided */
	char	*pfname ;		/* image file containing the 
								participants photo */
	struct	tm *arrival ;	/* Time when started vartalaap. Not the time 
								when she joins a particular group */	
	int	used ;			/* Flag indicating if the entry is filled or not */
	}	PARTICIPANTS_INFO ;

typedef	struct gtab {
		PARTICIPANTS_INFO	*pinfo;
		struct	gtab	*nxt ;
	} GRP_TAB ;

PARTICIPANTS_INFO	pinfo[MAXPARTICIPANTS] ;
GRP_TAB				*grouptable[VNGROUPS] ;

FD		groupfds[VNGROUPS][MAXPARTICIPANTS] ;
FD		groupaufds[VNGROUPS][MAXPARTICIPANTS] ;
FD		groupimgfds[VNGROUPS][MAXPARTICIPANTS] ;
FD		ausockfd, imgsockfd ;
int		participantsnumber[VNGROUPS] ;
int		image_channel_status[VNGROUPS];
int		audio_channel_status[VNGROUPS];
int		ImageGenFD[VNGROUPS] ;
	
char	*vhist_filename[VNGROUPS][MAX_PARTICIPANTS_PER_SESSION] ;
FILE	*vhist_file[VNGROUPS][MAX_PARTICIPANTS_PER_SESSION] ;
int		ImageIndex[VNGROUPS] ;
int		MessageNumber[VNGROUPS] ;
int		LastUid[VNGROUPS] ;
int		CurTxtPos[VNGROUPS][MAX_PARTICIPANTS_PER_SESSION] ;


