/*--------------------------------------------------------main.c--------------*/
/******************************************************************************/
/*                                                                            */
/*                                                                            */
/*                                Vartalaap                                   */
/*----------------------------------------------------------------------------*/
/*                     Multimedia Conferencing Software                       */
/*                                                                            */
/*                                                                            */
/*        Written by:                                                         */
/*                        Yezdezard Lashkari                                  */
/*                        Viswanath Ramachandran                              */
/*                        Sanjay Malpani                                      */
/*                    and                                                     */
/*                        Vijay Talati                                        */
/*                                                                            */
/*                                                                            */
/*                Department of Computer Science and Engineering              */
/*                Indian Institute of Technology, Bombay 400076.              */
/*                                                                            */
/******************************************************************************/

#include	<signal.h>
#include	"../common/inc.h"
#include	"globals.h"
#include	"ex_routines.h"
#include	"fncproto.h"

/*-------------------------------------------------------main()---------------*/
/* The main routine of the server.
 * After initialisations and creation of wellknown ports,
 * it goes into a loop where it waits for client requests and serves them
 */
/*----------------------------------------------------------------------------*/
main(argc, argv)
int	argc;
char	*argv[];
{

	ScanArgs(argc,argv);
	SetSignalHandling();
	SetLocalSigHandlers();
	
#ifdef DRS
	sigignore (SIGINT) ;
#else
	signal (SIGINT, SIG_IGN) ;
#endif

    (void)DetermineByteOrder();


	(void)init_group_tab();

	FD_ZERO(&ReadDescriptors);		/* Nothing as yet */

	InputPortFD = CreateWellKnownPort( GetServerPort()) ;

	MainLoop();
}
/*-------------------------------------------------------End of main.c--------*/
